require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&HEADER_DES_LOCL_H)) {
    eval 'sub HEADER_DES_LOCL_H () {1;}' unless defined(&HEADER_DES_LOCL_H);
    require 'sys/cdefs.ph';
    require 'sys/types.ph';
    require 'sys/systm.ph';
    require './crypto/des.ph';
    unless(defined(&DES_USE_PTR)) {
	undef(&DES_USE_PTR) if defined(&DES_USE_PTR);
    }
    unless(defined(&RAND)) {
	eval 'sub RAND () {1;}' unless defined(&RAND);
    }
    if(defined(&NOCONST)) {
	eval 'sub const () {1;}' unless defined(&const);
    }
    if(defined(&__STDC__)) {
	undef(&PROTO) if defined(&PROTO);
	eval 'sub PROTO () {1;}' unless defined(&PROTO);
    }
    if(defined(&RAND)) {
	eval 'sub srandom {
	    my($s) = @_;
    	    eval q( &srand($s));
	}' unless defined(&srandom);
	eval 'sub random () { &rand;}' unless defined(&random);
    }
    eval 'sub ITERATIONS () {16;}' unless defined(&ITERATIONS);
    eval 'sub HALF_ITERATIONS () {8;}' unless defined(&HALF_ITERATIONS);
    eval 'sub MAXWRITE () {(1024*16);}' unless defined(&MAXWRITE);
    eval 'sub BSIZE () {( &MAXWRITE+4);}' unless defined(&BSIZE);
    eval 'sub c2l {
        my($c,$l) = @_;
	    eval q(($l =(( &u_int32_t)(*(($c)++))) , $l|=(( &u_int32_t)(*(($c)++)))<< 8, $l|=(( &u_int32_t)(*(($c)++)))<<16, $l|=(( &u_int32_t)(*(($c)++)))<<24));
    }' unless defined(&c2l);
    eval 'sub c2ln {
        my($c,$l1,$l2,$n) = @_;
	    eval q({ $c+=$n; $l1=$l2=0;  &switch ($n) {  &case 8: $l2 =(( &u_int32_t)(*(--($c))))<<24;  &case 7: $l2|=(( &u_int32_t)(*(--($c))))<<16;  &case 6: $l2|=(( &u_int32_t)(*(--($c))))<< 8;  &case 5: $l2|=(( &u_int32_t)(*(--($c))));  &case 4: $l1 =(( &u_int32_t)(*(--($c))))<<24;  &case 3: $l1|=(( &u_int32_t)(*(--($c))))<<16;  &case 2: $l1|=(( &u_int32_t)(*(--($c))))<< 8;  &case 1: $l1|=(( &u_int32_t)(*(--($c)))); } });
    }' unless defined(&c2ln);
    eval 'sub l2c {
        my($l,$c) = @_;
	    eval q((*(++)=(&0xff), *(++)=((>> 8)&0xff), *(++)=((>>16)&0xff), *(++)=((($l)>>24)&0xff)));
    }' unless defined(&l2c);
    eval 'sub HDRSIZE () {4;}' unless defined(&HDRSIZE);
    eval 'sub n2l {
        my($c,$l) = @_;
	    eval q(($l =(( &u_int32_t)(*(($c)++)))<<24, $l|=(( &u_int32_t)(*(($c)++)))<<16, $l|=(( &u_int32_t)(*(($c)++)))<< 8, $l|=(( &u_int32_t)(*(($c)++)))));
    }' unless defined(&n2l);
    eval 'sub l2n {
        my($l,$c) = @_;
	    eval q((*(++)=((>>24)&0xff), *(++)=((>>16)&0xff), *(++)=((>> 8)&0xff), *(++)=((($l) )&0xff)));
    }' unless defined(&l2n);
    eval 'sub l2cn {
        my($l1,$l2,$c,$n) = @_;
	    eval q({ $c+=$n;  &switch {  &case 8: *(--)=((>>24)&0xff);  &case 7: *(--)=((>>16)&0xff);  &case 6: *(--)=((>> 8)&0xff);  &case 5: *(--)=(&0xff);  &case 4: *(--)=((>>24)&0xff);  &case 3: *(--)=((>>16)&0xff);  &case 2: *(--)=((>> 8)&0xff);  &case 1: *(--)=((($l1) )&0xff); } });
    }' unless defined(&l2cn);
    if(defined(&DES_USR_PTR)) {
	eval 'sub D_ENCRYPT {
	    my($L,$R,$S) = @_;
    	    eval q({  &u=(($R^ $s[$S ])<<2);  &t= $R^ $s[$S+1];  &t=(( &t>>2)+( &t<<30)); $L^= *( &u_int32_t *)( &des_SP+0x100+(( &t )&0xfc))+ *( &u_int32_t *)( &des_SP+0x300+(( &t>> 8)&0xfc))+ *( &u_int32_t *)( &des_SP+0x500+(( &t>>16)&0xfc))+ *( &u_int32_t *)( &des_SP+0x700+(( &t>>24)&0xfc))+ *( &u_int32_t *)( &des_SP+ (( &u )&0xfc))+ *( &u_int32_t *)( &des_SP+0x200+(( &u>> 8)&0xfc))+ *( &u_int32_t *)( &des_SP+0x400+(( &u>>16)&0xfc))+ *( &u_int32_t *)( &des_SP+0x600+(( &u>>24)&0xfc)); });
	}' unless defined(&D_ENCRYPT);
    } else {
	eval 'sub D_ENCRYPT {
	    my($Q,$R,$S) = @_;
    	    eval q({  &u=($R^ $s[$S ]);  &t=$R^ $s[$S+1];  &t=(( &t>>4)+( &t<<28)); $Q^=  $des_SPtrans[1][( &t )&0x3f]|  $des_SPtrans[3][( &t>> 8)&0x3f]|  $des_SPtrans[5][( &t>>16)&0x3f]|  $des_SPtrans[7][( &t>>24)&0x3f]|  $des_SPtrans[0][( &u )&0x3f]|  $des_SPtrans[2][( &u>> 8)&0x3f]|  $des_SPtrans[4][( &u>>16)&0x3f]|  $des_SPtrans[6][( &u>>24)&0x3f]; });
	}' unless defined(&D_ENCRYPT);
    }
    eval 'sub PERM_OP {
        my($a,$b,$t,$n,$m) = @_;
	    eval q((($t)=(((($a)>>($n))^($b))($m)), ($b)^=($t), ($a)^=(($t)<<($n))));
    }' unless defined(&PERM_OP);
    eval 'sub IP {
        my($l,$r) = @_;
	    eval q({  &register  &u_int32_t  &tt;  &PERM_OP($r,$l, &tt, 4,0xf0f0f0f);  &PERM_OP($l,$r, &tt,16,0xffff);  &PERM_OP($r,$l, &tt, 2,0x33333333);  &PERM_OP($l,$r, &tt, 8,0xff00ff);  &PERM_OP($r,$l, &tt, 1,0x55555555); });
    }' unless defined(&IP);
    eval 'sub FP {
        my($l,$r) = @_;
	    eval q({  &register  &u_int32_t  &tt;  &PERM_OP($l,$r, &tt, 1,0x55555555);  &PERM_OP($r,$l, &tt, 8,0xff00ff);  &PERM_OP($l,$r, &tt, 2,0x33333333);  &PERM_OP($r,$l, &tt,16,0xffff);  &PERM_OP($l,$r, &tt, 4,0xf0f0f0f); });
    }' unless defined(&FP);
}
1;
