require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&APC_CSR)) {
    sub APC_CSR () {	0x10;}
}
unless(defined(&APC_CVA)) {
    sub APC_CVA () {	0x20;}
}
unless(defined(&APC_CC)) {
    sub APC_CC () {	0x24;}
}
unless(defined(&APC_CNVA)) {
    sub APC_CNVA () {	0x28;}
}
unless(defined(&APC_CNC)) {
    sub APC_CNC () {	0x2c;}
}
unless(defined(&APC_PVA)) {
    sub APC_PVA () {	0x30;}
}
unless(defined(&APC_PC)) {
    sub APC_PC () {	0x34;}
}
unless(defined(&APC_PNVA)) {
    sub APC_PNVA () {	0x38;}
}
unless(defined(&APC_PNC)) {
    sub APC_PNC () {	0x3c;}
}
unless(defined(&APC_CSR_RESET)) {
    sub APC_CSR_RESET () {	0x1;}
}
unless(defined(&APC_CSR_CDMA_GO)) {
    sub APC_CSR_CDMA_GO () {	0x4;}
}
unless(defined(&APC_CSR_PDMA_GO)) {
    sub APC_CSR_PDMA_GO () {	0x8;}
}
unless(defined(&APC_CSR_CODEC_RESET)) {
    sub APC_CSR_CODEC_RESET () {	0x20;}
}
unless(defined(&APC_CSR_CPAUSE)) {
    sub APC_CSR_CPAUSE () {	0x40;}
}
unless(defined(&APC_CSR_PPAUSE)) {
    sub APC_CSR_PPAUSE () {	0x80;}
}
unless(defined(&APC_CSR_CMIE)) {
    sub APC_CSR_CMIE () {	0x100;}
}
unless(defined(&APC_CSR_CMI)) {
    sub APC_CSR_CMI () {	0x200;}
}
unless(defined(&APC_CSR_CD)) {
    sub APC_CSR_CD () {	0x400;}
}
unless(defined(&APC_CSR_CM)) {
    sub APC_CSR_CM () {	0x800;}
}
unless(defined(&APC_CSR_PMIE)) {
    sub APC_CSR_PMIE () {	0x1000;}
}
unless(defined(&APC_CSR_PD)) {
    sub APC_CSR_PD () {	0x2000;}
}
unless(defined(&APC_CSR_PM)) {
    sub APC_CSR_PM () {	0x4000;}
}
unless(defined(&APC_CSR_PMI)) {
    sub APC_CSR_PMI () {	0x8000;}
}
unless(defined(&APC_CSR_EIE)) {
    sub APC_CSR_EIE () {	0x10000;}
}
unless(defined(&APC_CSR_CIE)) {
    sub APC_CSR_CIE () {	0x20000;}
}
unless(defined(&APC_CSR_PIE)) {
    sub APC_CSR_PIE () {	0x40000;}
}
unless(defined(&APC_CSR_GIE)) {
    sub APC_CSR_GIE () {	0x80000;}
}
unless(defined(&APC_CSR_EI)) {
    sub APC_CSR_EI () {	0x100000;}
}
unless(defined(&APC_CSR_CI)) {
    sub APC_CSR_CI () {	0x200000;}
}
unless(defined(&APC_CSR_PI)) {
    sub APC_CSR_PI () {	0x400000;}
}
unless(defined(&APC_CSR_GI)) {
    sub APC_CSR_GI () {	0x800000;}
}
unless(defined(&APC_CSR_PLAY)) {
    sub APC_CSR_PLAY () {	(  &APC_CSR_EI |  &APC_CSR_GIE |  &APC_CSR_PIE |  &APC_CSR_EIE |  &APC_CSR_PDMA_GO |  &APC_CSR_PMIE );}
}
unless(defined(&APC_CSR_CAPTURE)) {
    sub APC_CSR_CAPTURE () {	(  &APC_CSR_EI |  &APC_CSR_GIE |  &APC_CSR_CIE |  &APC_CSR_EIE |  &APC_CSR_CDMA_GO );}
}
unless(defined(&APC_CSR_PLAY_PAUSE)) {
    sub APC_CSR_PLAY_PAUSE () {	(~(  &APC_CSR_PPAUSE |  &APC_CSR_GI |  &APC_CSR_PI |  &APC_CSR_CI |  &APC_CSR_EI |  &APC_CSR_PMI |  &APC_CSR_PMIE |  &APC_CSR_CMI |  &APC_CSR_CMIE ) );}
}
unless(defined(&APC_CSR_CAPTURE_PAUSE)) {
    sub APC_CSR_CAPTURE_PAUSE () {	(~(  &APC_CSR_PPAUSE |  &APC_CSR_GI |  &APC_CSR_PI |  &APC_CSR_CI |  &APC_CSR_EI |  &APC_CSR_PMI |  &APC_CSR_PMIE |  &APC_CSR_CMI |  &APC_CSR_CMIE ) );}
}
unless(defined(&APC_CSR_INTR_MASK)) {
    sub APC_CSR_INTR_MASK () {	(  &APC_CSR_GI |  &APC_CSR_PI |  &APC_CSR_CI |  &APC_CSR_EI |  &APC_CSR_PMI |  &APC_CSR_CMI );}
}
1;
