require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&CD1190_AWR)) {
    sub CD1190_AWR () {	0x3;}
}
unless(defined(&CD1190_CCR)) {
    sub CD1190_CCR () {	0xb;}
}
unless(defined(&CD1190_CCR_CGC)) {
    sub CD1190_CCR_CGC () {	(1<<7);}
}
unless(defined(&CD1190_CCR_CGC_RESET)) {
    sub CD1190_CCR_CGC_RESET () {	(1<<0);}
}
unless(defined(&CD1190_CCR_PAR)) {
    sub CD1190_CCR_PAR () {	(1<<6);}
}
unless(defined(&CD1190_CCR_PAR_DISABLE)) {
    sub CD1190_CCR_PAR_DISABLE () {	(1<<2);}
}
unless(defined(&CD1190_CCR_PAR_FLUSH)) {
    sub CD1190_CCR_PAR_FLUSH () {	(1<<1);}
}
unless(defined(&CD1190_CCR_PAR_ENABLE)) {
    sub CD1190_CCR_PAR_ENABLE () {	(1<<0);}
}
unless(defined(&CD1190_CCR_SIG)) {
    sub CD1190_CCR_SIG () {	(1<<5);}
}
unless(defined(&CD1190_CCR_SIG_SET_BUSY)) {
    sub CD1190_CCR_SIG_SET_BUSY () {	(1<<2);}
}
unless(defined(&CD1190_CCR_SIG_ACK)) {
    sub CD1190_CCR_SIG_ACK () {	(1<<1);}
}
unless(defined(&CD1190_CCR_SIG_CLR_BUSY)) {
    sub CD1190_CCR_SIG_CLR_BUSY () {	(1<<0);}
}
unless(defined(&CD1190_CCR_TIM)) {
    sub CD1190_CCR_TIM () {	(1<<4);}
}
unless(defined(&CD1190_CCR_TIM_ENABLE)) {
    sub CD1190_CCR_TIM_ENABLE () {	(1<<3);}
}
unless(defined(&CD1190_DTR)) {
    sub CD1190_DTR () {	0x9;}
}
unless(defined(&CD1190_ESR)) {
    sub CD1190_ESR () {	0x10;}
}
unless(defined(&CD1190_FCR)) {
    sub CD1190_FCR () {	0xe;}
}
unless(defined(&CD1190_FDR)) {
    sub CD1190_FDR () {	0x12;}
}
unless(defined(&CD1190_FRR)) {
    sub CD1190_FRR () {	0xf;}
}
unless(defined(&CD1190_FTR)) {
    sub CD1190_FTR () {	0x8;}
}
unless(defined(&CD1190_GCR)) {
    sub CD1190_GCR () {	0xa;}
}
unless(defined(&CD1190_GCR_NOACK)) {
    sub CD1190_GCR_NOACK () {	(1<<2);}
}
unless(defined(&CD1190_GCR_MODE)) {
    sub CD1190_GCR_MODE () {	(1<<1);}
}
unless(defined(&CD1190_GCR_DIR)) {
    sub CD1190_GCR_DIR () {	(1<<0);}
}
unless(defined(&CD1190_CO)) {
    sub CD1190_CO () {	0x;}
}
unless(defined(&CD1190_CI)) {
    sub CD1190_CI () {	0x1;}
}
unless(defined(&CD1190_PO)) {
    sub CD1190_PO () {	0x2;}
}
unless(defined(&CD1190_PI)) {
    sub CD1190_PI () {	0x3;}
}
unless(defined(&CD1190_ICR)) {
    sub CD1190_ICR () {	0x1;}
}
unless(defined(&CD1190_ICR_ENABLE)) {
    sub CD1190_ICR_ENABLE () {	(1<<7);}
}
unless(defined(&CD1190_ICR_ACK)) {
    sub CD1190_ICR_ACK () {	(1<<3);}
}
unless(defined(&CD1190_ICR_FIFO)) {
    sub CD1190_ICR_FIFO () {	(1<<2);}
}
unless(defined(&CD1190_ICR_SIGNAL)) {
    sub CD1190_ICR_SIGNAL () {	(1<<1);}
}
unless(defined(&CD1190_ICR_TIMER)) {
    sub CD1190_ICR_TIMER () {	(1<<0);}
}
unless(defined(&CD1190_ISR)) {
    sub CD1190_ISR () {	0xc;}
}
unless(defined(&CD1190_ISR_INTERRUPT)) {
    sub CD1190_ISR_INTERRUPT () {	(1<<7);}
}
unless(defined(&CD1190_ISR_ACK)) {
    sub CD1190_ISR_ACK () {	(1<<3);}
}
unless(defined(&CD1190_ISR_FIFO)) {
    sub CD1190_ISR_FIFO () {	(1<<2);}
}
unless(defined(&CD1190_ISR_SIGNAL)) {
    sub CD1190_ISR_SIGNAL () {	(1<<1);}
}
unless(defined(&CD1190_ISR_TIMER)) {
    sub CD1190_ISR_TIMER () {	(1<<0);}
}
unless(defined(&CD1190_IVR)) {
    sub CD1190_IVR () {	0x;}
}
unless(defined(&CD1190_PSR)) {
    sub CD1190_PSR () {	0x1c;}
}
unless(defined(&CD1190_PSR_ENP)) {
    sub CD1190_PSR_ENP () {	(1<<7);}
}
unless(defined(&CD1190_PSR_BUSY)) {
    sub CD1190_PSR_BUSY () {	(1<<6);}
}
unless(defined(&CD1190_PSR_ACK)) {
    sub CD1190_PSR_ACK () {	(1<<5);}
}
unless(defined(&CD1190_PSR_STATUS)) {
    sub CD1190_PSR_STATUS () {	( &CD1190_PSR_ENP |  &CD1190_PSR_BUSY);}
}
unless(defined(&CD1190_PSR_NORMAL)) {
    sub CD1190_PSR_NORMAL () {	 &CD1190_PSR_ENP;}
}
unless(defined(&CD1190_SCR)) {
    sub CD1190_SCR () {	0x1e;}
}
unless(defined(&CD1190_SCR_WRRD)) {
    sub CD1190_SCR_WRRD () {	(1<<7);}
}
unless(defined(&CD1190_SCR_IP3)) {
    sub CD1190_SCR_IP3 () {	(1<<6);}
}
unless(defined(&CD1190_SCR_IP2)) {
    sub CD1190_SCR_IP2 () {	(1<<5);}
}
unless(defined(&CD1190_SCR_IP1)) {
    sub CD1190_SCR_IP1 () {	(1<<4);}
}
unless(defined(&CD1190_SCR_WR_WRRD)) {
    sub CD1190_SCR_WR_WRRD () {	(1<<3);}
}
unless(defined(&CD1190_SCR_OP3)) {
    sub CD1190_SCR_OP3 () {	(1<<2);}
}
unless(defined(&CD1190_SCR_OP2)) {
    sub CD1190_SCR_OP2 () {	(1<<1);}
}
unless(defined(&CD1190_SCR_OP1)) {
    sub CD1190_SCR_OP1 () {	(1<<0);}
}
unless(defined(&CD1190_SCR_NOERROR)) {
    sub CD1190_SCR_NOERROR () {	 &CD1190_SCR_IP3;}
}
unless(defined(&CD1190_SCR_PE)) {
    sub CD1190_SCR_PE () {	 &CD1190_SCR_IP2;}
}
unless(defined(&CD1190_SCR_SELECT)) {
    sub CD1190_SCR_SELECT () {	 &CD1190_SCR_IP1;}
}
unless(defined(&CD1190_SCR_STATUS)) {
    sub CD1190_SCR_STATUS () {	( &CD1190_SCR_IP3 |  &CD1190_SCR_IP2 |  &CD1190_SCR_IP1);}
}
unless(defined(&CD1190_SCR_RESET)) {
    sub CD1190_SCR_RESET () {	 &CD1190_SCR_OP2;}
}
unless(defined(&CD1190_SCR_SEL_IN)) {
    sub CD1190_SCR_SEL_IN () {	 &CD1190_SCR_OP3;}
}
unless(defined(&CD1190_SR0)) {
    sub CD1190_SR0 () {	0x6;}
}
unless(defined(&CD1190_SR0_WRRD)) {
    sub CD1190_SR0_WRRD () {	(1<<7);}
}
unless(defined(&CD1190_SR0_IP3)) {
    sub CD1190_SR0_IP3 () {	(1<<6);}
}
unless(defined(&CD1190_SR0_IP2)) {
    sub CD1190_SR0_IP2 () {	(1<<5);}
}
unless(defined(&CD1190_SR0_IP1)) {
    sub CD1190_SR0_IP1 () {	(1<<4);}
}
unless(defined(&CD1190_SR1)) {
    sub CD1190_SR1 () {	0x7;}
}
unless(defined(&CD1190_SR1_WRRD)) {
    sub CD1190_SR1_WRRD () {	(1<<7);}
}
unless(defined(&CD1190_SR1_IP3)) {
    sub CD1190_SR1_IP3 () {	(1<<6);}
}
unless(defined(&CD1190_SR1_IP2)) {
    sub CD1190_SR1_IP2 () {	(1<<5);}
}
unless(defined(&CD1190_SR1_IP1)) {
    sub CD1190_SR1_IP1 () {	(1<<4);}
}
unless(defined(&CD1190_SSR)) {
    sub CD1190_SSR () {	0xd;}
}
unless(defined(&CD1190_SSR_WRRD)) {
    sub CD1190_SSR_WRRD () {	(1<<7);}
}
unless(defined(&CD1190_SSR_IP3)) {
    sub CD1190_SSR_IP3 () {	(1<<6);}
}
unless(defined(&CD1190_SSR_IP2)) {
    sub CD1190_SSR_IP2 () {	(1<<5);}
}
unless(defined(&CD1190_SSR_IP1)) {
    sub CD1190_SSR_IP1 () {	(1<<4);}
}
unless(defined(&CD1190_SWR)) {
    sub CD1190_SWR () {	0x2;}
}
unless(defined(&CD1190_TMR)) {
    sub CD1190_TMR () {	0x5;}
}
unless(defined(&CD1190_TPR)) {
    sub CD1190_TPR () {	0x4;}
}
1;
