require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&CD1400_NO_OF_CHANNELS)) {
    sub CD1400_NO_OF_CHANNELS () {	4;}
}
unless(defined(&CD1400_RX_FIFO_SIZE)) {
    sub CD1400_RX_FIFO_SIZE () {	12;}
}
unless(defined(&CD1400_TX_FIFO_SIZE)) {
    sub CD1400_TX_FIFO_SIZE () {	12;}
}
unless(defined(&CD1400_PAR_FIFO_SIZE)) {
    sub CD1400_PAR_FIFO_SIZE () {	30;}
}
unless(defined(&CD1400_GFRCR)) {
    sub CD1400_GFRCR () {	0x40;}
}
unless(defined(&CD1400_CAR)) {
    sub CD1400_CAR () {	0x68;}
}
unless(defined(&CD1400_CAR_CHAN)) {
    sub CD1400_CAR_CHAN () {	(3<<0);}
}
unless(defined(&CD1400_GCR)) {
    sub CD1400_GCR () {	0x4b;}
}
unless(defined(&CD1400_GCR_PARALLEL)) {
    sub CD1400_GCR_PARALLEL () {	(1<<7);}
}
unless(defined(&CD1400_SVRR)) {
    sub CD1400_SVRR () {	0x67;}
}
unless(defined(&CD1400_SVRR_MDMCH)) {
    sub CD1400_SVRR_MDMCH () {	(1<<2);}
}
unless(defined(&CD1400_SVRR_TXRDY)) {
    sub CD1400_SVRR_TXRDY () {	(1<<1);}
}
unless(defined(&CD1400_SVRR_RXRDY)) {
    sub CD1400_SVRR_RXRDY () {	(1<<0);}
}
unless(defined(&CD1400_RICR)) {
    sub CD1400_RICR () {	0x44;}
}
unless(defined(&CD1400_TICR)) {
    sub CD1400_TICR () {	0x45;}
}
unless(defined(&CD1400_MICR)) {
    sub CD1400_MICR () {	0x46;}
}
unless(defined(&CD1400_RIR)) {
    sub CD1400_RIR () {	0x6b;}
}
unless(defined(&CD1400_RIR_RDIREQ)) {
    sub CD1400_RIR_RDIREQ () {	(1<<7);}
}
unless(defined(&CD1400_RIR_RBUSY)) {
    sub CD1400_RIR_RBUSY () {	(1<<6);}
}
unless(defined(&CD1400_RIR_CHAN)) {
    sub CD1400_RIR_CHAN () {	(3<<0);}
}
unless(defined(&CD1400_TIR)) {
    sub CD1400_TIR () {	0x6a;}
}
unless(defined(&CD1400_TIR_RDIREQ)) {
    sub CD1400_TIR_RDIREQ () {	(1<<7);}
}
unless(defined(&CD1400_TIR_RBUSY)) {
    sub CD1400_TIR_RBUSY () {	(1<<6);}
}
unless(defined(&CD1400_TIR_CHAN)) {
    sub CD1400_TIR_CHAN () {	(3<<0);}
}
unless(defined(&CD1400_MIR)) {
    sub CD1400_MIR () {	0x69;}
}
unless(defined(&CD1400_MIR_RDIREQ)) {
    sub CD1400_MIR_RDIREQ () {	(1<<7);}
}
unless(defined(&CD1400_MIR_RBUSY)) {
    sub CD1400_MIR_RBUSY () {	(1<<6);}
}
unless(defined(&CD1400_MIR_CHAN)) {
    sub CD1400_MIR_CHAN () {	(3<<0);}
}
unless(defined(&CD1400_PPR)) {
    sub CD1400_PPR () {	0x7e;}
}
unless(defined(&CD1400_PPR_PRESCALER)) {
    sub CD1400_PPR_PRESCALER () {	512;}
}
unless(defined(&CD1400_RIVR)) {
    sub CD1400_RIVR () {	0x43;}
}
unless(defined(&CD1400_RIVR_EXCEPTION)) {
    sub CD1400_RIVR_EXCEPTION () {	(1<<2);}
}
unless(defined(&CD1400_TIVR)) {
    sub CD1400_TIVR () {	0x42;}
}
unless(defined(&CD1400_MIVR)) {
    sub CD1400_MIVR () {	0x41;}
}
unless(defined(&CD1400_TDR)) {
    sub CD1400_TDR () {	0x63;}
}
unless(defined(&CD1400_RDSR)) {
    sub CD1400_RDSR () {	0x62;}
}
unless(defined(&CD1400_RDSR_TIMEOUT)) {
    sub CD1400_RDSR_TIMEOUT () {	(1<<7);}
}
unless(defined(&CD1400_RDSR_SPECIAL_SHIFT)) {
    sub CD1400_RDSR_SPECIAL_SHIFT () {	4;}
}
unless(defined(&CD1400_RDSR_SPECIAL)) {
    sub CD1400_RDSR_SPECIAL () {	(7<<4);}
}
unless(defined(&CD1400_RDSR_BREAK)) {
    sub CD1400_RDSR_BREAK () {	(1<<3);}
}
unless(defined(&CD1400_RDSR_PE)) {
    sub CD1400_RDSR_PE () {	(1<<2);}
}
unless(defined(&CD1400_RDSR_FE)) {
    sub CD1400_RDSR_FE () {	(1<<1);}
}
unless(defined(&CD1400_RDSR_OE)) {
    sub CD1400_RDSR_OE () {	(1<<0);}
}
unless(defined(&CD1400_MISR)) {
    sub CD1400_MISR () {	0x4c;}
}
unless(defined(&CD1400_MISR_DSRd)) {
    sub CD1400_MISR_DSRd () {	(1<<7);}
}
unless(defined(&CD1400_MISR_CTSd)) {
    sub CD1400_MISR_CTSd () {	(1<<6);}
}
unless(defined(&CD1400_MISR_RId)) {
    sub CD1400_MISR_RId () {	(1<<5);}
}
unless(defined(&CD1400_MISR_CDd)) {
    sub CD1400_MISR_CDd () {	(1<<4);}
}
unless(defined(&CD1400_EOSRR)) {
    sub CD1400_EOSRR () {	0x60;}
}
unless(defined(&CD1400_LIVR)) {
    sub CD1400_LIVR () {	0x18;}
}
unless(defined(&CD1400_CCR)) {
    sub CD1400_CCR () {	0x5;}
}
unless(defined(&CD1400_CCR_CMDRESET)) {
    sub CD1400_CCR_CMDRESET () {	(1<<7);}
}
unless(defined(&CD1400_CCR_FTF)) {
    sub CD1400_CCR_FTF () {	(1<<1);}
}
unless(defined(&CD1400_CCR_FULLRESET)) {
    sub CD1400_CCR_FULLRESET () {	(1<<0);}
}
unless(defined(&CD1400_CCR_CMDCORCHG)) {
    sub CD1400_CCR_CMDCORCHG () {	(1<<6);}
}
unless(defined(&CD1400_CCR_COR3)) {
    sub CD1400_CCR_COR3 () {	(1<<3);}
}
unless(defined(&CD1400_CCR_COR2)) {
    sub CD1400_CCR_COR2 () {	(1<<2);}
}
unless(defined(&CD1400_CCR_COR1)) {
    sub CD1400_CCR_COR1 () {	(1<<1);}
}
unless(defined(&CD1400_CCR_CMDSENDSC)) {
    sub CD1400_CCR_CMDSENDSC () {	(1<<5);}
}
unless(defined(&CD1400_CCR_SC)) {
    sub CD1400_CCR_SC () {	(7<<0);}
}
unless(defined(&CD1400_CCR_CMDCHANCTL)) {
    sub CD1400_CCR_CMDCHANCTL () {	(1<<4);}
}
unless(defined(&CD1400_CCR_XMTEN)) {
    sub CD1400_CCR_XMTEN () {	(1<<3);}
}
unless(defined(&CD1400_CCR_XMTDIS)) {
    sub CD1400_CCR_XMTDIS () {	(1<<2);}
}
unless(defined(&CD1400_CCR_RCVEN)) {
    sub CD1400_CCR_RCVEN () {	(1<<1);}
}
unless(defined(&CD1400_CCR_RCVDIS)) {
    sub CD1400_CCR_RCVDIS () {	(1<<0);}
}
unless(defined(&CD1400_SRER)) {
    sub CD1400_SRER () {	0x6;}
}
unless(defined(&CD1400_SRER_MDMCH)) {
    sub CD1400_SRER_MDMCH () {	(1<<7);}
}
unless(defined(&CD1400_SRER_RXDATA)) {
    sub CD1400_SRER_RXDATA () {	(1<<4);}
}
unless(defined(&CD1400_SRER_TXRDY)) {
    sub CD1400_SRER_TXRDY () {	(1<<2);}
}
unless(defined(&CD1400_SRER_TXMPTY)) {
    sub CD1400_SRER_TXMPTY () {	(1<<1);}
}
unless(defined(&CD1400_SRER_NNDT)) {
    sub CD1400_SRER_NNDT () {	(1<<0);}
}
unless(defined(&CD1400_COR1)) {
    sub CD1400_COR1 () {	0x8;}
}
unless(defined(&CD1400_COR1_PARODD)) {
    sub CD1400_COR1_PARODD () {	(1<<7);}
}
unless(defined(&CD1400_COR1_PARNORMAL)) {
    sub CD1400_COR1_PARNORMAL () {	(2<<5);}
}
unless(defined(&CD1400_COR1_PARFORCE)) {
    sub CD1400_COR1_PARFORCE () {	(1<<5);}
}
unless(defined(&CD1400_COR1_PARNONE)) {
    sub CD1400_COR1_PARNONE () {	(0<<5);}
}
unless(defined(&CD1400_COR1_NOINPCK)) {
    sub CD1400_COR1_NOINPCK () {	(1<<4);}
}
unless(defined(&CD1400_COR1_STOP2)) {
    sub CD1400_COR1_STOP2 () {	(2<<2);}
}
unless(defined(&CD1400_COR1_STOP15)) {
    sub CD1400_COR1_STOP15 () {	(1<<2);}
}
unless(defined(&CD1400_COR1_STOP1)) {
    sub CD1400_COR1_STOP1 () {	(0<<2);}
}
unless(defined(&CD1400_COR1_CS8)) {
    sub CD1400_COR1_CS8 () {	(3<<0);}
}
unless(defined(&CD1400_COR1_CS7)) {
    sub CD1400_COR1_CS7 () {	(2<<0);}
}
unless(defined(&CD1400_COR1_CS6)) {
    sub CD1400_COR1_CS6 () {	(1<<0);}
}
unless(defined(&CD1400_COR1_CS5)) {
    sub CD1400_COR1_CS5 () {	(0<<0);}
}
unless(defined(&CD1400_COR2)) {
    sub CD1400_COR2 () {	0x9;}
}
unless(defined(&CD1400_COR2_IXANY)) {
    sub CD1400_COR2_IXANY () {	(1<<7);}
}
unless(defined(&CD1400_COR2_IXOFF)) {
    sub CD1400_COR2_IXOFF () {	(1<<6);}
}
unless(defined(&CD1400_COR2_ETC)) {
    sub CD1400_COR2_ETC () {	(1<<5);}
}
unless(defined(&CD1400_COR2_LLM)) {
    sub CD1400_COR2_LLM () {	(1<<4);}
}
unless(defined(&CD1400_COR2_RLM)) {
    sub CD1400_COR2_RLM () {	(1<<3);}
}
unless(defined(&CD1400_COR2_RTSAO)) {
    sub CD1400_COR2_RTSAO () {	(1<<2);}
}
unless(defined(&CD1400_COR2_CCTS_OFLOW)) {
    sub CD1400_COR2_CCTS_OFLOW () {	(1<<1);}
}
unless(defined(&CD1400_COR2_CDSR_OFLOW)) {
    sub CD1400_COR2_CDSR_OFLOW () {	(1<<0);}
}
unless(defined(&CD1400_COR3)) {
    sub CD1400_COR3 () {	0xa;}
}
unless(defined(&CD1400_COR3_SCDRNG)) {
    sub CD1400_COR3_SCDRNG () {	(1<<7);}
}
unless(defined(&CD1400_COR3_SCD34)) {
    sub CD1400_COR3_SCD34 () {	(1<<6);}
}
unless(defined(&CD1400_COR3_FTC)) {
    sub CD1400_COR3_FTC () {	(1<<5);}
}
unless(defined(&CD1400_COR3_SCD12)) {
    sub CD1400_COR3_SCD12 () {	(1<<4);}
}
unless(defined(&CD1400_COR3_RXTH)) {
    sub CD1400_COR3_RXTH () {	(15<<0);}
}
unless(defined(&CD1400_COR4)) {
    sub CD1400_COR4 () {	0x1e;}
}
unless(defined(&CD1400_COR4_IGNCR)) {
    sub CD1400_COR4_IGNCR () {	(1<<7);}
}
unless(defined(&CD1400_COR4_ICRNL)) {
    sub CD1400_COR4_ICRNL () {	(1<<6);}
}
unless(defined(&CD1400_COR4_INLCR)) {
    sub CD1400_COR4_INLCR () {	(1<<5);}
}
unless(defined(&CD1400_COR4_IGNBRK)) {
    sub CD1400_COR4_IGNBRK () {	(1<<4);}
}
unless(defined(&CD1400_COR4_NOBRKINT)) {
    sub CD1400_COR4_NOBRKINT () {	(1<<3);}
}
unless(defined(&CD1400_COR4_PFO_ESC)) {
    sub CD1400_COR4_PFO_ESC () {	(4<<0);}
}
unless(defined(&CD1400_COR4_PFO_NUL)) {
    sub CD1400_COR4_PFO_NUL () {	(3<<0);}
}
unless(defined(&CD1400_COR4_PFO_DISCARD)) {
    sub CD1400_COR4_PFO_DISCARD () {	(2<<0);}
}
unless(defined(&CD1400_COR4_PFO_GOOD)) {
    sub CD1400_COR4_PFO_GOOD () {	(1<<0);}
}
unless(defined(&CD1400_COR4_PFO_EXCEPTION)) {
    sub CD1400_COR4_PFO_EXCEPTION () {	(0<<0);}
}
unless(defined(&CD1400_COR5)) {
    sub CD1400_COR5 () {	0x1f;}
}
unless(defined(&CD1400_COR5_ISTRIP)) {
    sub CD1400_COR5_ISTRIP () {	(1<<7);}
}
unless(defined(&CD1400_COR5_LNEXT)) {
    sub CD1400_COR5_LNEXT () {	(1<<6);}
}
unless(defined(&CD1400_COR5_CMOE)) {
    sub CD1400_COR5_CMOE () {	(1<<5);}
}
unless(defined(&CD1400_COR5_EBD)) {
    sub CD1400_COR5_EBD () {	(1<<2);}
}
unless(defined(&CD1400_COR5_ONLCR)) {
    sub CD1400_COR5_ONLCR () {	(1<<1);}
}
unless(defined(&CD1400_COR5_OCRNL)) {
    sub CD1400_COR5_OCRNL () {	(1<<0);}
}
unless(defined(&CD1400_CCSR)) {
    sub CD1400_CCSR () {	0xb;}
}
unless(defined(&CD1400_RDCR)) {
    sub CD1400_RDCR () {	0xe;}
}
unless(defined(&CD1400_SCHR1)) {
    sub CD1400_SCHR1 () {	0x1a;}
}
unless(defined(&CD1400_SCHR2)) {
    sub CD1400_SCHR2 () {	0x1b;}
}
unless(defined(&CD1400_SCHR3)) {
    sub CD1400_SCHR3 () {	0x1c;}
}
unless(defined(&CD1400_SCHR4)) {
    sub CD1400_SCHR4 () {	0x1d;}
}
unless(defined(&CD1400_SCRL)) {
    sub CD1400_SCRL () {	0x22;}
}
unless(defined(&CD1400_SCRH)) {
    sub CD1400_SCRH () {	0x23;}
}
unless(defined(&CD1400_LNC)) {
    sub CD1400_LNC () {	0x24;}
}
unless(defined(&CD1400_MCOR1)) {
    sub CD1400_MCOR1 () {	0x15;}
}
unless(defined(&CD1400_MCOR1_DSRzd)) {
    sub CD1400_MCOR1_DSRzd () {	(1<<7);}
}
unless(defined(&CD1400_MCOR1_CTSzd)) {
    sub CD1400_MCOR1_CTSzd () {	(1<<6);}
}
unless(defined(&CD1400_MCOR1_RIzd)) {
    sub CD1400_MCOR1_RIzd () {	(1<<5);}
}
unless(defined(&CD1400_MCOR1_CDzd)) {
    sub CD1400_MCOR1_CDzd () {	(1<<4);}
}
unless(defined(&CD1400_MCOR1_DTRth)) {
    sub CD1400_MCOR1_DTRth () {	(15<<0);}
}
unless(defined(&CD1400_MCOR2)) {
    sub CD1400_MCOR2 () {	0x16;}
}
unless(defined(&CD1400_MCOR2_DSRod)) {
    sub CD1400_MCOR2_DSRod () {	(1<<7);}
}
unless(defined(&CD1400_MCOR2_CTSod)) {
    sub CD1400_MCOR2_CTSod () {	(1<<6);}
}
unless(defined(&CD1400_MCOR2_RIod)) {
    sub CD1400_MCOR2_RIod () {	(1<<5);}
}
unless(defined(&CD1400_MCOR2_CDod)) {
    sub CD1400_MCOR2_CDod () {	(1<<4);}
}
unless(defined(&CD1400_RTPR)) {
    sub CD1400_RTPR () {	0x21;}
}
unless(defined(&CD1400_MSVR1)) {
    sub CD1400_MSVR1 () {	0x6c;}
}
unless(defined(&CD1400_MSVR1_RTS)) {
    sub CD1400_MSVR1_RTS () {	(1<<0);}
}
unless(defined(&CD1400_MSVR2)) {
    sub CD1400_MSVR2 () {	0x6d;}
}
unless(defined(&CD1400_MSVR2_DSR)) {
    sub CD1400_MSVR2_DSR () {	(1<<7);}
}
unless(defined(&CD1400_MSVR2_CTS)) {
    sub CD1400_MSVR2_CTS () {	(1<<6);}
}
unless(defined(&CD1400_MSVR2_RI)) {
    sub CD1400_MSVR2_RI () {	(1<<5);}
}
unless(defined(&CD1400_MSVR2_CD)) {
    sub CD1400_MSVR2_CD () {	(1<<4);}
}
unless(defined(&CD1400_MSVR2_DTR)) {
    sub CD1400_MSVR2_DTR () {	(1<<1);}
}
unless(defined(&CD1400_PSVR)) {
    sub CD1400_PSVR () {	0x6f;}
}
unless(defined(&CD1400_RBPR)) {
    sub CD1400_RBPR () {	0x78;}
}
unless(defined(&CD1400_RCOR)) {
    sub CD1400_RCOR () {	0x7c;}
}
unless(defined(&CD1400_TBPR)) {
    sub CD1400_TBPR () {	0x72;}
}
unless(defined(&CD1400_TCOR)) {
    sub CD1400_TCOR () {	0x76;}
}
1;
