require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&BS_BAR)) {
    sub BS_BAR () {	0x10;}
}
unless(defined(&BS_TRDY_TIMEOUT)) {
    sub BS_TRDY_TIMEOUT () {	0x40;}
}
unless(defined(&BS_RETRY_TIMEOUT)) {
    sub BS_RETRY_TIMEOUT () {	0x41;}
}
unless(defined(&UBS_PCI_RTY_SHIFT)) {
    sub UBS_PCI_RTY_SHIFT () {	8;}
}
unless(defined(&UBS_PCI_RTY_MASK)) {
    sub UBS_PCI_RTY_MASK () {	0xff;}
}
unless(defined(&UBS_PCI_RTY)) {
    sub UBS_PCI_RTY {
	my($misc) = @_;
	eval q(((($misc) >>  &UBS_PCI_RTY_SHIFT) &  &UBS_PCI_RTY_MASK));
    }
}
unless(defined(&UBS_PCI_TOUT_SHIFT)) {
    sub UBS_PCI_TOUT_SHIFT () {	0;}
}
unless(defined(&UBS_PCI_TOUT_MASK)) {
    sub UBS_PCI_TOUT_MASK () {	0xff;}
}
unless(defined(&UBS_PCI_TOUT)) {
    sub UBS_PCI_TOUT {
	my($misc) = @_;
	eval q(((($misc) >>  &PCI_TOUT_SHIFT) &  &PCI_TOUT_MASK));
    }
}
unless(defined(&BS_MCR1)) {
    sub BS_MCR1 () {	0x;}
}
unless(defined(&BS_CTRL)) {
    sub BS_CTRL () {	0x4;}
}
unless(defined(&BS_STAT)) {
    sub BS_STAT () {	0x8;}
}
unless(defined(&BS_ERR)) {
    sub BS_ERR () {	0xc;}
}
unless(defined(&BS_MCR2)) {
    sub BS_MCR2 () {	0x10;}
}
unless(defined(&BS_MCR3)) {
    sub BS_MCR3 () {	0x14;}
}
unless(defined(&BS_MCR4)) {
    sub BS_MCR4 () {	0x1c;}
}
unless(defined(&BS_CFG)) {
    sub BS_CFG () {	0x700;}
}
unless(defined(&BS_INT)) {
    sub BS_INT () {	0xf00;}
}
unless(defined(&BS_CTRL_RESET)) {
    sub BS_CTRL_RESET () {	0x80000000;}
}
unless(defined(&BS_CTRL_MCR2INT)) {
    sub BS_CTRL_MCR2INT () {	0x40000000;}
}
unless(defined(&BS_CTRL_MCR1INT)) {
    sub BS_CTRL_MCR1INT () {	0x20000000;}
}
unless(defined(&BS_CTRL_OFM)) {
    sub BS_CTRL_OFM () {	0x10000000;}
}
unless(defined(&BS_CTRL_BE32)) {
    sub BS_CTRL_BE32 () {	0x8000000;}
}
unless(defined(&BS_CTRL_BE64)) {
    sub BS_CTRL_BE64 () {	0x4000000;}
}
unless(defined(&BS_CTRL_DMAERR)) {
    sub BS_CTRL_DMAERR () {	0x2000000;}
}
unless(defined(&BS_CTRL_RNG_M)) {
    sub BS_CTRL_RNG_M () {	0x1800000;}
}
unless(defined(&BS_CTRL_RNG_1)) {
    sub BS_CTRL_RNG_1 () {	0x;}
}
unless(defined(&BS_CTRL_RNG_4)) {
    sub BS_CTRL_RNG_4 () {	0x800000;}
}
unless(defined(&BS_CTRL_RNG_8)) {
    sub BS_CTRL_RNG_8 () {	0x1000000;}
}
unless(defined(&BS_CTRL_RNG_16)) {
    sub BS_CTRL_RNG_16 () {	0x1800000;}
}
unless(defined(&BS_CTRL_SWNORM)) {
    sub BS_CTRL_SWNORM () {	0x400000;}
}
unless(defined(&BS_CTRL_MCR3INT)) {
    sub BS_CTRL_MCR3INT () {	0x400000;}
}
unless(defined(&BS_CTRL_MCR4INT)) {
    sub BS_CTRL_MCR4INT () {	0x200000;}
}
unless(defined(&BS_CTRL_BSIZE240)) {
    sub BS_CTRL_BSIZE240 () {	0xf0000;}
}
unless(defined(&BS_CTRL_FRAG_M)) {
    sub BS_CTRL_FRAG_M () {	0xffff;}
}
unless(defined(&BS_CTRL_LITTLE_ENDIAN)) {
    sub BS_CTRL_LITTLE_ENDIAN () {	( &BS_CTRL_BE32 |  &BS_CTRL_BE64);}
}
unless(defined(&BS_STAT_MCR_BUSY)) {
    sub BS_STAT_MCR_BUSY () {	0x80000000;}
}
unless(defined(&BS_STAT_MCR1_FULL)) {
    sub BS_STAT_MCR1_FULL () {	0x40000000;}
}
unless(defined(&BS_STAT_MCR1_DONE)) {
    sub BS_STAT_MCR1_DONE () {	0x20000000;}
}
unless(defined(&BS_STAT_DMAERR)) {
    sub BS_STAT_DMAERR () {	0x10000000;}
}
unless(defined(&BS_STAT_MCR2_FULL)) {
    sub BS_STAT_MCR2_FULL () {	0x8000000;}
}
unless(defined(&BS_STAT_MCR2_DONE)) {
    sub BS_STAT_MCR2_DONE () {	0x4000000;}
}
unless(defined(&BS_STAT_MCR1_ALLEMPTY)) {
    sub BS_STAT_MCR1_ALLEMPTY () {	0x2000000;}
}
unless(defined(&BS_STAT_MCR2_ALLEMPTY)) {
    sub BS_STAT_MCR2_ALLEMPTY () {	0x1000000;}
}
unless(defined(&BS_STAT_MCR3_ALLEMPTY)) {
    sub BS_STAT_MCR3_ALLEMPTY () {	0x800000;}
}
unless(defined(&BS_STAT_MCR4_ALLEMPTY)) {
    sub BS_STAT_MCR4_ALLEMPTY () {	0x400000;}
}
unless(defined(&BS_STAT_MCR3_FULL)) {
    sub BS_STAT_MCR3_FULL () {	0x80000;}
}
unless(defined(&BS_STAT_MCR3_DONE)) {
    sub BS_STAT_MCR3_DONE () {	0x40000;}
}
unless(defined(&BS_STAT_MCR4_FULL)) {
    sub BS_STAT_MCR4_FULL () {	0x20000;}
}
unless(defined(&BS_STAT_MCR4_DONE)) {
    sub BS_STAT_MCR4_DONE () {	0x10000;}
}
unless(defined(&BS_ERR_ADDR)) {
    sub BS_ERR_ADDR () {	0xfffffffc;}
}
unless(defined(&BS_ERR_READ)) {
    sub BS_ERR_READ () {	0x2;}
}
unless(defined(&BS_CFG_RNG)) {
    sub BS_CFG_RNG () {	0x1;}
}
unless(defined(&BS_INT_DMAINT)) {
    sub BS_INT_DMAINT () {	0x80000000;}
}
unless(defined(&UBS_PKTCTX_ENC_3DES)) {
    sub UBS_PKTCTX_ENC_3DES () {	0x8000;}
}
unless(defined(&UBS_PKTCTX_ENC_NONE)) {
    sub UBS_PKTCTX_ENC_NONE () {	0x;}
}
unless(defined(&UBS_PKTCTX_INBOUND)) {
    sub UBS_PKTCTX_INBOUND () {	0x4000;}
}
unless(defined(&UBS_PKTCTX_AUTH)) {
    sub UBS_PKTCTX_AUTH () {	0x3000;}
}
unless(defined(&UBS_PKTCTX_AUTH_NONE)) {
    sub UBS_PKTCTX_AUTH_NONE () {	0x;}
}
unless(defined(&UBS_PKTCTX_AUTH_MD5)) {
    sub UBS_PKTCTX_AUTH_MD5 () {	0x1000;}
}
unless(defined(&UBS_PKTCTX_AUTH_SHA1)) {
    sub UBS_PKTCTX_AUTH_SHA1 () {	0x2000;}
}
unless(defined(&UBS_PKTCTX_TYPE_IPSEC_3DES)) {
    sub UBS_PKTCTX_TYPE_IPSEC_3DES () {	0x;}
}
unless(defined(&UBS_PKTCTX_TYPE_IPSEC_AES)) {
    sub UBS_PKTCTX_TYPE_IPSEC_AES () {	0x40;}
}
unless(defined(&UBS_PKTCTX_ENC_AES)) {
    sub UBS_PKTCTX_ENC_AES () {	0x8000;}
}
unless(defined(&UBS_PKTCTX_MODE_CBC)) {
    sub UBS_PKTCTX_MODE_CBC () {	0x;}
}
unless(defined(&UBS_PKTCTX_MODE_CTR)) {
    sub UBS_PKTCTX_MODE_CTR () {	0x400;}
}
unless(defined(&UBS_PKTCTX_KEYSIZE_128)) {
    sub UBS_PKTCTX_KEYSIZE_128 () {	0x;}
}
unless(defined(&UBS_PKTCTX_KEYSIZE_192)) {
    sub UBS_PKTCTX_KEYSIZE_192 () {	0x100;}
}
unless(defined(&UBS_PKTCTX_KEYSIZE_256)) {
    sub UBS_PKTCTX_KEYSIZE_256 () {	0x200;}
}
unless(defined(&UBS_PKTBUF_LEN)) {
    sub UBS_PKTBUF_LEN () {	0xffff;}
}
unless(defined(&UBS_MCR_DONE)) {
    sub UBS_MCR_DONE () {	0x1;}
}
unless(defined(&UBS_MCR_ERROR)) {
    sub UBS_MCR_ERROR () {	0x2;}
}
unless(defined(&UBS_MCR_ERRORCODE)) {
    sub UBS_MCR_ERRORCODE () {	0xff00;}
}
unless(defined(&UBS_CTXOP_DHPKGEN)) {
    sub UBS_CTXOP_DHPKGEN () {	0x1;}
}
unless(defined(&UBS_CTXOP_DHSSGEN)) {
    sub UBS_CTXOP_DHSSGEN () {	0x2;}
}
unless(defined(&UBS_CTXOP_RSAPUB)) {
    sub UBS_CTXOP_RSAPUB () {	0x3;}
}
unless(defined(&UBS_CTXOP_RSAPRIV)) {
    sub UBS_CTXOP_RSAPRIV () {	0x4;}
}
unless(defined(&UBS_CTXOP_DSASIGN)) {
    sub UBS_CTXOP_DSASIGN () {	0x5;}
}
unless(defined(&UBS_CTXOP_DSAVRFY)) {
    sub UBS_CTXOP_DSAVRFY () {	0x6;}
}
unless(defined(&UBS_CTXOP_RNGBYPASS)) {
    sub UBS_CTXOP_RNGBYPASS () {	0x41;}
}
unless(defined(&UBS_CTXOP_RNGSHA1)) {
    sub UBS_CTXOP_RNGSHA1 () {	0x42;}
}
unless(defined(&UBS_CTXOP_MODADD)) {
    sub UBS_CTXOP_MODADD () {	0x43;}
}
unless(defined(&UBS_CTXOP_MODSUB)) {
    sub UBS_CTXOP_MODSUB () {	0x44;}
}
unless(defined(&UBS_CTXOP_MODMUL)) {
    sub UBS_CTXOP_MODMUL () {	0x45;}
}
unless(defined(&UBS_CTXOP_MODRED)) {
    sub UBS_CTXOP_MODRED () {	0x46;}
}
unless(defined(&UBS_CTXOP_MODEXP)) {
    sub UBS_CTXOP_MODEXP () {	0x47;}
}
unless(defined(&UBS_CTXOP_MODINV)) {
    sub UBS_CTXOP_MODINV () {	0x48;}
}
1;
