require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MALO_READ_1)) {
    sub MALO_READ_1 {
	my($sc, $reg) = @_;
	eval q( &bus_space_read_1(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg)));
    }
}
unless(defined(&MALO_READ_2)) {
    sub MALO_READ_2 {
	my($sc, $reg) = @_;
	eval q( &bus_space_read_2(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg)));
    }
}
unless(defined(&MALO_READ_MULTI_2)) {
    sub MALO_READ_MULTI_2 {
	my($sc, $reg, $off, $size) = @_;
	eval q( &bus_space_read_raw_multi_2(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg), ($off), ($size)));
    }
}
unless(defined(&MALO_WRITE_1)) {
    sub MALO_WRITE_1 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_space_write_1(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg), ($val)));
    }
}
unless(defined(&MALO_WRITE_2)) {
    sub MALO_WRITE_2 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_space_write_2(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg), ($val)));
    }
}
unless(defined(&MALO_WRITE_MULTI_2)) {
    sub MALO_WRITE_MULTI_2 {
	my($sc, $reg, $off, $size) = @_;
	eval q( &bus_space_write_raw_multi_2(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg), ($off), ($size)));
    }
}
unless(defined(&MALO_FW_HELPER_BSIZE)) {
    sub MALO_FW_HELPER_BSIZE () {	256;}
}
unless(defined(&MALO_FW_HELPER_LOADED)) {
    sub MALO_FW_HELPER_LOADED () {	0x10;}
}
unless(defined(&MALO_FW_MAIN_MAXRETRY)) {
    sub MALO_FW_MAIN_MAXRETRY () {	20;}
}
unless(defined(&MALO_CMD_BUFFER_SIZE)) {
    sub MALO_CMD_BUFFER_SIZE () {	256;}
}
unless(defined(&MALO_DEVICE_ATTACHED)) {
    sub MALO_DEVICE_ATTACHED () {	(1<< 0);}
}
unless(defined(&MALO_FW_LOADED)) {
    sub MALO_FW_LOADED () {	(1<< 1);}
}
unless(defined(&MALO_ASSOC_FAILED)) {
    sub MALO_ASSOC_FAILED () {	(1<< 2);}
}
unless(defined(&MALO_BUSY)) {
    sub MALO_BUSY () {	(1<< 3);}
}
unless(defined(&MALO_WEP_ACTION_TYPE_ADD)) {
    sub MALO_WEP_ACTION_TYPE_ADD () {	0x2;}
}
unless(defined(&MALO_WEP_ACTION_TYPE_REMOVE)) {
    sub MALO_WEP_ACTION_TYPE_REMOVE () {	0x4;}
}
unless(defined(&MALO_WEP_ACTION_TYPE_DEFAULT)) {
    sub MALO_WEP_ACTION_TYPE_DEFAULT () {	0x8;}
}
unless(defined(&MALO_WEP_KEY_TYPE_40BIT)) {
    sub MALO_WEP_KEY_TYPE_40BIT () {	0x1;}
}
unless(defined(&MALO_WEP_KEY_TYPE_104BIT)) {
    sub MALO_WEP_KEY_TYPE_104BIT () {	0x2;}
}
unless(defined(&MALO_OID_BSS)) {
    sub MALO_OID_BSS () {	0x;}
}
unless(defined(&MALO_OID_RATE)) {
    sub MALO_OID_RATE () {	0x1;}
}
unless(defined(&MALO_OID_BCNPERIOD)) {
    sub MALO_OID_BCNPERIOD () {	0x2;}
}
unless(defined(&MALO_OID_DTIMPERIOD)) {
    sub MALO_OID_DTIMPERIOD () {	0x3;}
}
unless(defined(&MALO_OID_ASSOCTIMEOUT)) {
    sub MALO_OID_ASSOCTIMEOUT () {	0x4;}
}
unless(defined(&MALO_OID_RTSTRESH)) {
    sub MALO_OID_RTSTRESH () {	0x5;}
}
unless(defined(&MALO_OID_SHORTRETRY)) {
    sub MALO_OID_SHORTRETRY () {	0x6;}
}
unless(defined(&MALO_OID_LONGRETRY)) {
    sub MALO_OID_LONGRETRY () {	0x7;}
}
unless(defined(&MALO_OID_FRAGTRESH)) {
    sub MALO_OID_FRAGTRESH () {	0x8;}
}
unless(defined(&MALO_OID_80211D)) {
    sub MALO_OID_80211D () {	0x9;}
}
unless(defined(&MALO_OID_80211H)) {
    sub MALO_OID_80211H () {	0xa;}
}
unless(defined(&MALO_RATE_BITMAP_DS1)) {
    sub MALO_RATE_BITMAP_DS1 () {	(1<< 0);}
}
unless(defined(&MALO_RATE_BITMAP_DS2)) {
    sub MALO_RATE_BITMAP_DS2 () {	(1<< 1);}
}
unless(defined(&MALO_RATE_BITMAP_DS5)) {
    sub MALO_RATE_BITMAP_DS5 () {	(1<< 2);}
}
unless(defined(&MALO_RATE_BITMAP_DS11)) {
    sub MALO_RATE_BITMAP_DS11 () {	(1<< 3);}
}
unless(defined(&MALO_RATE_BITMAP_OFDM6)) {
    sub MALO_RATE_BITMAP_OFDM6 () {	(1<< 5);}
}
unless(defined(&MALO_RATE_BITMAP_OFDM9)) {
    sub MALO_RATE_BITMAP_OFDM9 () {	(1<< 6);}
}
unless(defined(&MALO_RATE_BITMAP_OFDM12)) {
    sub MALO_RATE_BITMAP_OFDM12 () {	(1<< 7);}
}
unless(defined(&MALO_RATE_BITMAP_OFDM18)) {
    sub MALO_RATE_BITMAP_OFDM18 () {	(1<< 8);}
}
unless(defined(&MALO_RATE_BITMAP_OFDM24)) {
    sub MALO_RATE_BITMAP_OFDM24 () {	(1<< 9);}
}
unless(defined(&MALO_RATE_BITMAP_OFDM36)) {
    sub MALO_RATE_BITMAP_OFDM36 () {	(1<< 10);}
}
unless(defined(&MALO_RATE_BITMAP_OFDM48)) {
    sub MALO_RATE_BITMAP_OFDM48 () {	(1<< 11);}
}
unless(defined(&MALO_RATE_BITMAP_OFDM54)) {
    sub MALO_RATE_BITMAP_OFDM54 () {	(1<< 12);}
}
unless(defined(&MALO_RATE_BITMAP_AUTO)) {
    sub MALO_RATE_BITMAP_AUTO () {	0x1fef;}
}
unless(defined(&MALO_TLV_TYPE_SSID)) {
    sub MALO_TLV_TYPE_SSID () {	0x;}
}
unless(defined(&MALO_TLV_TYPE_RATES)) {
    sub MALO_TLV_TYPE_RATES () {	0x1;}
}
unless(defined(&MALO_TLV_TYPE_PHY)) {
    sub MALO_TLV_TYPE_PHY () {	0x3;}
}
unless(defined(&MALO_TLV_TYPE_CF)) {
    sub MALO_TLV_TYPE_CF () {	0x4;}
}
unless(defined(&MALO_TLV_TYPE_80211D)) {
    sub MALO_TLV_TYPE_80211D () {	0x7;}
}
unless(defined(&MALO_TLV_TYPE_CHANLIST)) {
    sub MALO_TLV_TYPE_CHANLIST () {	0x101;}
}
unless(defined(&MALO_TLV_TYPE_NUMPROBES)) {
    sub MALO_TLV_TYPE_NUMPROBES () {	0x102;}
}
unless(defined(&MALO_TLV_TYPE_PASSEID)) {
    sub MALO_TLV_TYPE_PASSEID () {	0x10a;}
}
unless(defined(&CHANNELS)) {
    sub CHANNELS () {	12;}
}
unless(defined(&MALO_RX_STATUS_OK)) {
    sub MALO_RX_STATUS_OK () {	0x1;}
}
1;
