require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&UPGT_RX_RADIOTAP_PRESENT)) {
    sub UPGT_RX_RADIOTAP_PRESENT () {	((1<<  &IEEE80211_RADIOTAP_FLAGS) | (1<<  &IEEE80211_RADIOTAP_RATE) | (1<<  &IEEE80211_RADIOTAP_CHANNEL) | (1<<  &IEEE80211_RADIOTAP_DB_ANTSIGNAL));}
}
unless(defined(&UPGT_TX_RADIOTAP_PRESENT)) {
    sub UPGT_TX_RADIOTAP_PRESENT () {	((1<<  &IEEE80211_RADIOTAP_FLAGS) | (1<<  &IEEE80211_RADIOTAP_RATE) | (1<<  &IEEE80211_RADIOTAP_CHANNEL));}
}
unless(defined(&UPGT_IFACE_INDEX)) {
    sub UPGT_IFACE_INDEX () {	0;}
}
unless(defined(&UPGT_CONFIG_NO)) {
    sub UPGT_CONFIG_NO () {	1;}
}
unless(defined(&UPGT_USB_TIMEOUT)) {
    sub UPGT_USB_TIMEOUT () {	1000;}
}
unless(defined(&UPGT_FIRMWARE_TIMEOUT)) {
    sub UPGT_FIRMWARE_TIMEOUT () {	10;}
}
unless(defined(&UPGT_MEMADDR_FIRMWARE_START)) {
    sub UPGT_MEMADDR_FIRMWARE_START () {	0x20000;}
}
unless(defined(&UPGT_MEMSIZE_FRAME_HEAD)) {
    sub UPGT_MEMSIZE_FRAME_HEAD () {	0x70;}
}
unless(defined(&UPGT_MEMSIZE_RX)) {
    sub UPGT_MEMSIZE_RX () {	0x3500;}
}
unless(defined(&UPGT_TX_COUNT)) {
    sub UPGT_TX_COUNT () {	6;}
}
unless(defined(&UPGT_DEVICE_ATTACHED)) {
    sub UPGT_DEVICE_ATTACHED () {	(1<< 0);}
}
unless(defined(&UPGT_LED_OFF)) {
    sub UPGT_LED_OFF () {	0;}
}
unless(defined(&UPGT_LED_ON)) {
    sub UPGT_LED_ON () {	1;}
}
unless(defined(&UPGT_LED_BLINK)) {
    sub UPGT_LED_BLINK () {	2;}
}
unless(defined(&UPGT_FW_BLOCK_SIZE)) {
    sub UPGT_FW_BLOCK_SIZE () {	512;}
}
unless(defined(&UPGT_BRA_FWTYPE_SIZE)) {
    sub UPGT_BRA_FWTYPE_SIZE () {	4;}
}
unless(defined(&UPGT_BRA_FWTYPE_LM86)) {
    sub UPGT_BRA_FWTYPE_LM86 () {	"LM86";}
}
unless(defined(&UPGT_BRA_FWTYPE_LM87)) {
    sub UPGT_BRA_FWTYPE_LM87 () {	"LM87";}
}
unless(defined(&UPGT_BRA_FWTYPE_FMAC)) {
    sub UPGT_BRA_FWTYPE_FMAC () {	"FMAC";}
}
eval("sub UPGT_FWTYPE_LM86 () { 0; }") unless defined(&UPGT_FWTYPE_LM86);
eval("sub UPGT_FWTYPE_LM87 () { 1; }") unless defined(&UPGT_FWTYPE_LM87);
eval("sub UPGT_FWTYPE_FMAC () { 2; }") unless defined(&UPGT_FWTYPE_FMAC);
unless(defined(&UPGT_BRA_TYPE_FW)) {
    sub UPGT_BRA_TYPE_FW () {	0x80000001;}
}
unless(defined(&UPGT_BRA_TYPE_VERSION)) {
    sub UPGT_BRA_TYPE_VERSION () {	0x80000002;}
}
unless(defined(&UPGT_BRA_TYPE_DEPIF)) {
    sub UPGT_BRA_TYPE_DEPIF () {	0x80000003;}
}
unless(defined(&UPGT_BRA_TYPE_EXPIF)) {
    sub UPGT_BRA_TYPE_EXPIF () {	0x80000004;}
}
unless(defined(&UPGT_BRA_TYPE_DESCR)) {
    sub UPGT_BRA_TYPE_DESCR () {	0x80000101;}
}
unless(defined(&UPGT_BRA_TYPE_END)) {
    sub UPGT_BRA_TYPE_END () {	0xff0000ff;}
}
unless(defined(&UPGT_X2_SIGNATURE_SIZE)) {
    sub UPGT_X2_SIGNATURE_SIZE () {	4;}
}
unless(defined(&UPGT_X2_SIGNATURE)) {
    sub UPGT_X2_SIGNATURE () {	"x2  ";}
}
unless(defined(&UPGT_EEPROM_SIZE)) {
    sub UPGT_EEPROM_SIZE () {	8192;}
}
unless(defined(&UPGT_EEPROM_BLOCK_SIZE)) {
    sub UPGT_EEPROM_BLOCK_SIZE () {	1020;}
}
unless(defined(&UPGT_EEPROM_TYPE_END)) {
    sub UPGT_EEPROM_TYPE_END () {	0x;}
}
unless(defined(&UPGT_EEPROM_TYPE_NAME)) {
    sub UPGT_EEPROM_TYPE_NAME () {	0x1;}
}
unless(defined(&UPGT_EEPROM_TYPE_SERIAL)) {
    sub UPGT_EEPROM_TYPE_SERIAL () {	0x3;}
}
unless(defined(&UPGT_EEPROM_TYPE_MAC)) {
    sub UPGT_EEPROM_TYPE_MAC () {	0x101;}
}
unless(defined(&UPGT_EEPROM_TYPE_HWRX)) {
    sub UPGT_EEPROM_TYPE_HWRX () {	0x1001;}
}
unless(defined(&UPGT_EEPROM_TYPE_CHIP)) {
    sub UPGT_EEPROM_TYPE_CHIP () {	0x1002;}
}
unless(defined(&UPGT_EEPROM_TYPE_FREQ3)) {
    sub UPGT_EEPROM_TYPE_FREQ3 () {	0x1903;}
}
unless(defined(&UPGT_EEPROM_TYPE_FREQ4)) {
    sub UPGT_EEPROM_TYPE_FREQ4 () {	0x1904;}
}
unless(defined(&UPGT_EEPROM_TYPE_FREQ5)) {
    sub UPGT_EEPROM_TYPE_FREQ5 () {	0x1905;}
}
unless(defined(&UPGT_EEPROM_TYPE_FREQ6)) {
    sub UPGT_EEPROM_TYPE_FREQ6 () {	0x1906;}
}
unless(defined(&UPGT_EEPROM_TYPE_OFF)) {
    sub UPGT_EEPROM_TYPE_OFF () {	0xffff;}
}
unless(defined(&UPGT_EEPROM_RX_CONST)) {
    sub UPGT_EEPROM_RX_CONST () {	0x88;}
}
unless(defined(&UPGT_H1_FLAGS_TX_MGMT)) {
    sub UPGT_H1_FLAGS_TX_MGMT () {	0x;}
}
unless(defined(&UPGT_H1_FLAGS_TX_NO_CALLBACK)) {
    sub UPGT_H1_FLAGS_TX_NO_CALLBACK () {	0x1;}
}
unless(defined(&UPGT_H1_FLAGS_TX_DATA)) {
    sub UPGT_H1_FLAGS_TX_DATA () {	0x10;}
}
unless(defined(&UPGT_H1_TYPE_RX_DATA)) {
    sub UPGT_H1_TYPE_RX_DATA () {	0x;}
}
unless(defined(&UPGT_H1_TYPE_RX_DATA_MGMT)) {
    sub UPGT_H1_TYPE_RX_DATA_MGMT () {	0x4;}
}
unless(defined(&UPGT_H1_TYPE_TX_DATA)) {
    sub UPGT_H1_TYPE_TX_DATA () {	0x40;}
}
unless(defined(&UPGT_H1_TYPE_CTRL)) {
    sub UPGT_H1_TYPE_CTRL () {	0x80;}
}
unless(defined(&UPGT_H2_TYPE_TX_ACK_NO)) {
    sub UPGT_H2_TYPE_TX_ACK_NO () {	0x;}
}
unless(defined(&UPGT_H2_TYPE_TX_ACK_YES)) {
    sub UPGT_H2_TYPE_TX_ACK_YES () {	0x1;}
}
unless(defined(&UPGT_H2_TYPE_MACFILTER)) {
    sub UPGT_H2_TYPE_MACFILTER () {	0x;}
}
unless(defined(&UPGT_H2_TYPE_CHANNEL)) {
    sub UPGT_H2_TYPE_CHANNEL () {	0x1;}
}
unless(defined(&UPGT_H2_TYPE_TX_DONE)) {
    sub UPGT_H2_TYPE_TX_DONE () {	0x8;}
}
unless(defined(&UPGT_H2_TYPE_STATS)) {
    sub UPGT_H2_TYPE_STATS () {	0xa;}
}
unless(defined(&UPGT_H2_TYPE_EEPROM)) {
    sub UPGT_H2_TYPE_EEPROM () {	0xc;}
}
unless(defined(&UPGT_H2_TYPE_LED)) {
    sub UPGT_H2_TYPE_LED () {	0xd;}
}
unless(defined(&UPGT_H2_FLAGS_TX_ACK_NO)) {
    sub UPGT_H2_FLAGS_TX_ACK_NO () {	0x101;}
}
unless(defined(&UPGT_H2_FLAGS_TX_ACK_YES)) {
    sub UPGT_H2_FLAGS_TX_ACK_YES () {	0x707;}
}
unless(defined(&UPGT_FILTER_TYPE_NONE)) {
    sub UPGT_FILTER_TYPE_NONE () {	0x;}
}
unless(defined(&UPGT_FILTER_TYPE_STA)) {
    sub UPGT_FILTER_TYPE_STA () {	0x1;}
}
unless(defined(&UPGT_FILTER_TYPE_IBSS)) {
    sub UPGT_FILTER_TYPE_IBSS () {	0x2;}
}
unless(defined(&UPGT_FILTER_TYPE_HOSTAP)) {
    sub UPGT_FILTER_TYPE_HOSTAP () {	0x4;}
}
unless(defined(&UPGT_FILTER_TYPE_MONITOR)) {
    sub UPGT_FILTER_TYPE_MONITOR () {	0x10;}
}
unless(defined(&UPGT_FILTER_TYPE_RESET)) {
    sub UPGT_FILTER_TYPE_RESET () {	0x20;}
}
unless(defined(&UPGT_FILTER_UNKNOWN1)) {
    sub UPGT_FILTER_UNKNOWN1 () {	0x2;}
}
unless(defined(&UPGT_FILTER_UNKNOWN2)) {
    sub UPGT_FILTER_UNKNOWN2 () {	0xca8;}
}
unless(defined(&UPGT_FILTER_UNKNOWN3)) {
    sub UPGT_FILTER_UNKNOWN3 () {	0xffff;}
}
unless(defined(&UPGT_CHANNEL_UNKNOWN1)) {
    sub UPGT_CHANNEL_UNKNOWN1 () {	0x1;}
}
unless(defined(&UPGT_CHANNEL_UNKNOWN2)) {
    sub UPGT_CHANNEL_UNKNOWN2 () {	0x;}
}
unless(defined(&UPGT_CHANNEL_UNKNOWN3)) {
    sub UPGT_CHANNEL_UNKNOWN3 () {	0x48;}
}
unless(defined(&UPGT_LED_MODE_SET)) {
    sub UPGT_LED_MODE_SET () {	0x3;}
}
unless(defined(&UPGT_LED_ACTION_OFF)) {
    sub UPGT_LED_ACTION_OFF () {	0x2;}
}
unless(defined(&UPGT_LED_ACTION_ON)) {
    sub UPGT_LED_ACTION_ON () {	0x3;}
}
unless(defined(&UPGT_LED_ACTION_TMP_DUR)) {
    sub UPGT_LED_ACTION_TMP_DUR () {	100;}
}
unless(defined(&UPGT_TX_DESC_KEY_EXISTS)) {
    sub UPGT_TX_DESC_KEY_EXISTS () {	0x1;}
}
unless(defined(&UPGT_TX_DESC_TYPE_BEACON)) {
    sub UPGT_TX_DESC_TYPE_BEACON () {	0x;}
}
unless(defined(&UPGT_TX_DESC_TYPE_PROBE)) {
    sub UPGT_TX_DESC_TYPE_PROBE () {	0x1;}
}
unless(defined(&UPGT_TX_DESC_TYPE_MGMT)) {
    sub UPGT_TX_DESC_TYPE_MGMT () {	0x2;}
}
unless(defined(&UPGT_TX_DESC_TYPE_DATA)) {
    sub UPGT_TX_DESC_TYPE_DATA () {	0x4;}
}
unless(defined(&UPGT_TX_DESC_PAD3_SIZE)) {
    sub UPGT_TX_DESC_PAD3_SIZE () {	2;}
}
unless(defined(&UPGT_TX_DONE_DESC_STATUS_OK)) {
    sub UPGT_TX_DONE_DESC_STATUS_OK () {	0x1;}
}
unless(defined(&UPGT_MEMORY_MAX_PAGES)) {
    sub UPGT_MEMORY_MAX_PAGES () {	8;}
}
if((defined(&NBPFILTER) ? &NBPFILTER : undef) > 0) {
    eval 'sub sc_rxtap () { ($sc_rxtapu->{th});}' unless defined(&sc_rxtap);
    eval 'sub sc_txtap () { ($sc_txtapu->{th});}' unless defined(&sc_txtap);
}
1;
