require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&UAUDIO_VERSION)) {
    sub UAUDIO_VERSION () {	0x100;}
}
unless(defined(&UDESC_CS_CONFIG)) {
    sub UDESC_CS_CONFIG () {	0x22;}
}
unless(defined(&UDESC_CS_STRING)) {
    sub UDESC_CS_STRING () {	0x23;}
}
unless(defined(&UDESC_CS_INTERFACE)) {
    sub UDESC_CS_INTERFACE () {	0x24;}
}
unless(defined(&UDESC_CS_ENDPOINT)) {
    sub UDESC_CS_ENDPOINT () {	0x25;}
}
unless(defined(&UDESCSUB_AC_HEADER)) {
    sub UDESCSUB_AC_HEADER () {	1;}
}
unless(defined(&UDESCSUB_AC_INPUT)) {
    sub UDESCSUB_AC_INPUT () {	2;}
}
unless(defined(&UDESCSUB_AC_OUTPUT)) {
    sub UDESCSUB_AC_OUTPUT () {	3;}
}
unless(defined(&UDESCSUB_AC_MIXER)) {
    sub UDESCSUB_AC_MIXER () {	4;}
}
unless(defined(&UDESCSUB_AC_SELECTOR)) {
    sub UDESCSUB_AC_SELECTOR () {	5;}
}
unless(defined(&UDESCSUB_AC_FEATURE)) {
    sub UDESCSUB_AC_FEATURE () {	6;}
}
unless(defined(&UDESCSUB_AC_PROCESSING)) {
    sub UDESCSUB_AC_PROCESSING () {	7;}
}
unless(defined(&UDESCSUB_AC_EXTENSION)) {
    sub UDESCSUB_AC_EXTENSION () {	8;}
}
unless(defined(&USB_ENDPOINT_DESCRIPTOR_AUDIO_SIZE)) {
    sub USB_ENDPOINT_DESCRIPTOR_AUDIO_SIZE () {	9;}
}
unless(defined(&UA_SED_FREQ_CONTROL)) {
    sub UA_SED_FREQ_CONTROL () {	0x1;}
}
unless(defined(&UA_SED_PITCH_CONTROL)) {
    sub UA_SED_PITCH_CONTROL () {	0x2;}
}
unless(defined(&UA_SED_MAXPACKETSONLY)) {
    sub UA_SED_MAXPACKETSONLY () {	0x80;}
}
unless(defined(&UA_SAMP_CONTNUOUS)) {
    sub UA_SAMP_CONTNUOUS () {	0;}
}
unless(defined(&UA_GETSAMP)) {
    sub UA_GETSAMP {
	my($p, $n) = @_;
	eval q((($p)-> $tSamFreq[($n)*3+0] | (($p)-> $tSamFreq[($n)*3+1] << 8) | (($p)-> $tSamFreq[($n)*3+2] << 16)));
    }
}
unless(defined(&UA_SAMP_LO)) {
    sub UA_SAMP_LO {
	my($p) = @_;
	eval q( &UA_GETSAMP($p, 0));
    }
}
unless(defined(&UA_SAMP_HI)) {
    sub UA_SAMP_HI {
	my($p) = @_;
	eval q( &UA_GETSAMP($p, 1));
    }
}
unless(defined(&UA_PROC_ENABLE_MASK)) {
    sub UA_PROC_ENABLE_MASK () {	1;}
}
unless(defined(&UA_EXT_ENABLE_MASK)) {
    sub UA_EXT_ENABLE_MASK () {	1;}
}
unless(defined(&UA_EXT_ENABLE)) {
    sub UA_EXT_ENABLE () {	1;}
}
unless(defined(&UAT_UNDEFINED)) {
    sub UAT_UNDEFINED () {	0x100;}
}
unless(defined(&UAT_STREAM)) {
    sub UAT_STREAM () {	0x101;}
}
unless(defined(&UAT_VENDOR)) {
    sub UAT_VENDOR () {	0x1ff;}
}
unless(defined(&UATI_UNDEFINED)) {
    sub UATI_UNDEFINED () {	0x200;}
}
unless(defined(&UATI_MICROPHONE)) {
    sub UATI_MICROPHONE () {	0x201;}
}
unless(defined(&UATI_DESKMICROPHONE)) {
    sub UATI_DESKMICROPHONE () {	0x202;}
}
unless(defined(&UATI_PERSONALMICROPHONE)) {
    sub UATI_PERSONALMICROPHONE () {	0x203;}
}
unless(defined(&UATI_OMNIMICROPHONE)) {
    sub UATI_OMNIMICROPHONE () {	0x204;}
}
unless(defined(&UATI_MICROPHONEARRAY)) {
    sub UATI_MICROPHONEARRAY () {	0x205;}
}
unless(defined(&UATI_PROCMICROPHONEARR)) {
    sub UATI_PROCMICROPHONEARR () {	0x206;}
}
unless(defined(&UATO_UNDEFINED)) {
    sub UATO_UNDEFINED () {	0x300;}
}
unless(defined(&UATO_SPEAKER)) {
    sub UATO_SPEAKER () {	0x301;}
}
unless(defined(&UATO_HEADPHONES)) {
    sub UATO_HEADPHONES () {	0x302;}
}
unless(defined(&UATO_DISPLAYAUDIO)) {
    sub UATO_DISPLAYAUDIO () {	0x303;}
}
unless(defined(&UATO_DESKTOPSPEAKER)) {
    sub UATO_DESKTOPSPEAKER () {	0x304;}
}
unless(defined(&UATO_ROOMSPEAKER)) {
    sub UATO_ROOMSPEAKER () {	0x305;}
}
unless(defined(&UATO_COMMSPEAKER)) {
    sub UATO_COMMSPEAKER () {	0x306;}
}
unless(defined(&UATO_SUBWOOFER)) {
    sub UATO_SUBWOOFER () {	0x307;}
}
unless(defined(&UATB_UNDEFINED)) {
    sub UATB_UNDEFINED () {	0x400;}
}
unless(defined(&UATB_HANDSET)) {
    sub UATB_HANDSET () {	0x401;}
}
unless(defined(&UATB_HEADSET)) {
    sub UATB_HEADSET () {	0x402;}
}
unless(defined(&UATB_SPEAKERPHONE)) {
    sub UATB_SPEAKERPHONE () {	0x403;}
}
unless(defined(&UATB_SPEAKERPHONEESUP)) {
    sub UATB_SPEAKERPHONEESUP () {	0x404;}
}
unless(defined(&UATB_SPEAKERPHONEECANC)) {
    sub UATB_SPEAKERPHONEECANC () {	0x405;}
}
unless(defined(&UATT_UNDEFINED)) {
    sub UATT_UNDEFINED () {	0x500;}
}
unless(defined(&UATT_PHONELINE)) {
    sub UATT_PHONELINE () {	0x501;}
}
unless(defined(&UATT_TELEPHONE)) {
    sub UATT_TELEPHONE () {	0x502;}
}
unless(defined(&UATT_DOWNLINEPHONE)) {
    sub UATT_DOWNLINEPHONE () {	0x503;}
}
unless(defined(&UATE_UNDEFINED)) {
    sub UATE_UNDEFINED () {	0x600;}
}
unless(defined(&UATE_ANALOGCONN)) {
    sub UATE_ANALOGCONN () {	0x601;}
}
unless(defined(&UATE_DIGITALAUIFC)) {
    sub UATE_DIGITALAUIFC () {	0x602;}
}
unless(defined(&UATE_LINECONN)) {
    sub UATE_LINECONN () {	0x603;}
}
unless(defined(&UATE_LEGACYCONN)) {
    sub UATE_LEGACYCONN () {	0x604;}
}
unless(defined(&UATE_SPDIF)) {
    sub UATE_SPDIF () {	0x605;}
}
unless(defined(&UATE_1394DA)) {
    sub UATE_1394DA () {	0x606;}
}
unless(defined(&UATE_1394DV)) {
    sub UATE_1394DV () {	0x607;}
}
unless(defined(&UATF_UNDEFINED)) {
    sub UATF_UNDEFINED () {	0x700;}
}
unless(defined(&UATF_CALIBNOISE)) {
    sub UATF_CALIBNOISE () {	0x701;}
}
unless(defined(&UATF_EQUNOISE)) {
    sub UATF_EQUNOISE () {	0x702;}
}
unless(defined(&UATF_CDPLAYER)) {
    sub UATF_CDPLAYER () {	0x703;}
}
unless(defined(&UATF_DAT)) {
    sub UATF_DAT () {	0x704;}
}
unless(defined(&UATF_DCC)) {
    sub UATF_DCC () {	0x705;}
}
unless(defined(&UATF_MINIDISK)) {
    sub UATF_MINIDISK () {	0x706;}
}
unless(defined(&UATF_ANALOGTAPE)) {
    sub UATF_ANALOGTAPE () {	0x707;}
}
unless(defined(&UATF_PHONOGRAPH)) {
    sub UATF_PHONOGRAPH () {	0x708;}
}
unless(defined(&UATF_VCRAUDIO)) {
    sub UATF_VCRAUDIO () {	0x709;}
}
unless(defined(&UATF_VIDEODISCAUDIO)) {
    sub UATF_VIDEODISCAUDIO () {	0x70a;}
}
unless(defined(&UATF_DVDAUDIO)) {
    sub UATF_DVDAUDIO () {	0x70b;}
}
unless(defined(&UATF_TVTUNERAUDIO)) {
    sub UATF_TVTUNERAUDIO () {	0x70c;}
}
unless(defined(&UATF_SATELLITE)) {
    sub UATF_SATELLITE () {	0x70d;}
}
unless(defined(&UATF_CABLETUNER)) {
    sub UATF_CABLETUNER () {	0x70e;}
}
unless(defined(&UATF_DSS)) {
    sub UATF_DSS () {	0x70f;}
}
unless(defined(&UATF_RADIORECV)) {
    sub UATF_RADIORECV () {	0x710;}
}
unless(defined(&UATF_RADIOXMIT)) {
    sub UATF_RADIOXMIT () {	0x711;}
}
unless(defined(&UATF_MULTITRACK)) {
    sub UATF_MULTITRACK () {	0x712;}
}
unless(defined(&UATF_SYNTHESIZER)) {
    sub UATF_SYNTHESIZER () {	0x713;}
}
unless(defined(&SET_CUR)) {
    sub SET_CUR () {	0x1;}
}
unless(defined(&GET_CUR)) {
    sub GET_CUR () {	0x81;}
}
unless(defined(&SET_MIN)) {
    sub SET_MIN () {	0x2;}
}
unless(defined(&GET_MIN)) {
    sub GET_MIN () {	0x82;}
}
unless(defined(&SET_MAX)) {
    sub SET_MAX () {	0x3;}
}
unless(defined(&GET_MAX)) {
    sub GET_MAX () {	0x83;}
}
unless(defined(&SET_RES)) {
    sub SET_RES () {	0x4;}
}
unless(defined(&GET_RES)) {
    sub GET_RES () {	0x84;}
}
unless(defined(&SET_MEM)) {
    sub SET_MEM () {	0x5;}
}
unless(defined(&GET_MEM)) {
    sub GET_MEM () {	0x85;}
}
unless(defined(&GET_STAT)) {
    sub GET_STAT () {	0xff;}
}
unless(defined(&MUTE_CONTROL)) {
    sub MUTE_CONTROL () {	0x1;}
}
unless(defined(&VOLUME_CONTROL)) {
    sub VOLUME_CONTROL () {	0x2;}
}
unless(defined(&BASS_CONTROL)) {
    sub BASS_CONTROL () {	0x3;}
}
unless(defined(&MID_CONTROL)) {
    sub MID_CONTROL () {	0x4;}
}
unless(defined(&TREBLE_CONTROL)) {
    sub TREBLE_CONTROL () {	0x5;}
}
unless(defined(&GRAPHIC_EQUALIZER_CONTROL)) {
    sub GRAPHIC_EQUALIZER_CONTROL () {	0x6;}
}
unless(defined(&AGC_CONTROL)) {
    sub AGC_CONTROL () {	0x7;}
}
unless(defined(&DELAY_CONTROL)) {
    sub DELAY_CONTROL () {	0x8;}
}
unless(defined(&BASS_BOOST_CONTROL)) {
    sub BASS_BOOST_CONTROL () {	0x9;}
}
unless(defined(&LOUDNESS_CONTROL)) {
    sub LOUDNESS_CONTROL () {	0xa;}
}
unless(defined(&FU_MASK)) {
    sub FU_MASK {
	my($u) = @_;
	eval q((1<< (($u)-1)));
    }
}
unless(defined(&MASTER_CHAN)) {
    sub MASTER_CHAN () {	0;}
}
unless(defined(&AS_GENERAL)) {
    sub AS_GENERAL () {	1;}
}
unless(defined(&FORMAT_TYPE)) {
    sub FORMAT_TYPE () {	2;}
}
unless(defined(&FORMAT_SPECIFIC)) {
    sub FORMAT_SPECIFIC () {	3;}
}
unless(defined(&UA_FMT_PCM)) {
    sub UA_FMT_PCM () {	1;}
}
unless(defined(&UA_FMT_PCM8)) {
    sub UA_FMT_PCM8 () {	2;}
}
unless(defined(&UA_FMT_IEEE_FLOAT)) {
    sub UA_FMT_IEEE_FLOAT () {	3;}
}
unless(defined(&UA_FMT_ALAW)) {
    sub UA_FMT_ALAW () {	4;}
}
unless(defined(&UA_FMT_MULAW)) {
    sub UA_FMT_MULAW () {	5;}
}
unless(defined(&UA_FMT_MPEG)) {
    sub UA_FMT_MPEG () {	0x1001;}
}
unless(defined(&UA_FMT_AC3)) {
    sub UA_FMT_AC3 () {	0x1002;}
}
unless(defined(&SAMPLING_FREQ_CONTROL)) {
    sub SAMPLING_FREQ_CONTROL () {	0x1;}
}
unless(defined(&PITCH_CONTROL)) {
    sub PITCH_CONTROL () {	0x2;}
}
unless(defined(&FORMAT_TYPE_UNDEFINED)) {
    sub FORMAT_TYPE_UNDEFINED () {	0;}
}
unless(defined(&FORMAT_TYPE_I)) {
    sub FORMAT_TYPE_I () {	1;}
}
unless(defined(&FORMAT_TYPE_II)) {
    sub FORMAT_TYPE_II () {	2;}
}
unless(defined(&FORMAT_TYPE_III)) {
    sub FORMAT_TYPE_III () {	3;}
}
unless(defined(&UA_PROC_MASK)) {
    sub UA_PROC_MASK {
	my($n) = @_;
	eval q((1<< (($n)-1)));
    }
}
unless(defined(&PROCESS_UNDEFINED)) {
    sub PROCESS_UNDEFINED () {	0;}
}
unless(defined(&XX_ENABLE_CONTROL)) {
    sub XX_ENABLE_CONTROL () {	1;}
}
unless(defined(&UPDOWNMIX_PROCESS)) {
    sub UPDOWNMIX_PROCESS () {	1;}
}
unless(defined(&UD_ENABLE_CONTROL)) {
    sub UD_ENABLE_CONTROL () {	1;}
}
unless(defined(&UD_MODE_SELECT_CONTROL)) {
    sub UD_MODE_SELECT_CONTROL () {	2;}
}
unless(defined(&DOLBY_PROLOGIC_PROCESS)) {
    sub DOLBY_PROLOGIC_PROCESS () {	2;}
}
unless(defined(&DP_ENABLE_CONTROL)) {
    sub DP_ENABLE_CONTROL () {	1;}
}
unless(defined(&DP_MODE_SELECT_CONTROL)) {
    sub DP_MODE_SELECT_CONTROL () {	2;}
}
unless(defined(&P3D_STEREO_EXTENDER_PROCESS)) {
    sub P3D_STEREO_EXTENDER_PROCESS () {	3;}
}
unless(defined(&P3D_ENABLE_CONTROL)) {
    sub P3D_ENABLE_CONTROL () {	1;}
}
unless(defined(&P3D_SPACIOUSNESS_CONTROL)) {
    sub P3D_SPACIOUSNESS_CONTROL () {	2;}
}
unless(defined(&REVERBATION_PROCESS)) {
    sub REVERBATION_PROCESS () {	4;}
}
unless(defined(&RV_ENABLE_CONTROL)) {
    sub RV_ENABLE_CONTROL () {	1;}
}
unless(defined(&RV_LEVEL_CONTROL)) {
    sub RV_LEVEL_CONTROL () {	2;}
}
unless(defined(&RV_TIME_CONTROL)) {
    sub RV_TIME_CONTROL () {	3;}
}
unless(defined(&RV_FEEDBACK_CONTROL)) {
    sub RV_FEEDBACK_CONTROL () {	4;}
}
unless(defined(&CHORUS_PROCESS)) {
    sub CHORUS_PROCESS () {	5;}
}
unless(defined(&CH_ENABLE_CONTROL)) {
    sub CH_ENABLE_CONTROL () {	1;}
}
unless(defined(&CH_LEVEL_CONTROL)) {
    sub CH_LEVEL_CONTROL () {	2;}
}
unless(defined(&CH_RATE_CONTROL)) {
    sub CH_RATE_CONTROL () {	3;}
}
unless(defined(&CH_DEPTH_CONTROL)) {
    sub CH_DEPTH_CONTROL () {	4;}
}
unless(defined(&DYN_RANGE_COMP_PROCESS)) {
    sub DYN_RANGE_COMP_PROCESS () {	6;}
}
unless(defined(&DR_ENABLE_CONTROL)) {
    sub DR_ENABLE_CONTROL () {	1;}
}
unless(defined(&DR_COMPRESSION_RATE_CONTROL)) {
    sub DR_COMPRESSION_RATE_CONTROL () {	2;}
}
unless(defined(&DR_MAXAMPL_CONTROL)) {
    sub DR_MAXAMPL_CONTROL () {	3;}
}
unless(defined(&DR_THRESHOLD_CONTROL)) {
    sub DR_THRESHOLD_CONTROL () {	4;}
}
unless(defined(&DR_ATTACK_TIME_CONTROL)) {
    sub DR_ATTACK_TIME_CONTROL () {	5;}
}
unless(defined(&DR_RELEASE_TIME_CONTROL)) {
    sub DR_RELEASE_TIME_CONTROL () {	6;}
}
1;
