require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&HEADER_DH_H)) {
    eval 'sub HEADER_DH_H () {1;}' unless defined(&HEADER_DH_H);
    require 'openssl/e_os2.ph';
    if(defined(&OPENSSL_NO_DH)) {
	die("DH\ is\ disabled\.");
    }
    unless(defined(&OPENSSL_NO_BIO)) {
	require 'openssl/bio.ph';
    }
    require 'openssl/ossl_typ.ph';
    unless(defined(&OPENSSL_NO_DEPRECATED)) {
	require 'openssl/bn.ph';
    }
    unless(defined(&OPENSSL_DH_MAX_MODULUS_BITS)) {
	eval 'sub OPENSSL_DH_MAX_MODULUS_BITS () {10000;}' unless defined(&OPENSSL_DH_MAX_MODULUS_BITS);
    }
    eval 'sub DH_FLAG_CACHE_MONT_P () {0x1;}' unless defined(&DH_FLAG_CACHE_MONT_P);
    eval 'sub DH_FLAG_NO_EXP_CONSTTIME () {0x2;}' unless defined(&DH_FLAG_NO_EXP_CONSTTIME);
    if(defined(&__cplusplus)) {
    }
    eval 'sub DH_GENERATOR_2 () {2;}' unless defined(&DH_GENERATOR_2);
    eval 'sub DH_GENERATOR_5 () {5;}' unless defined(&DH_GENERATOR_5);
    eval 'sub DH_CHECK_P_NOT_PRIME () {0x1;}' unless defined(&DH_CHECK_P_NOT_PRIME);
    eval 'sub DH_CHECK_P_NOT_SAFE_PRIME () {0x2;}' unless defined(&DH_CHECK_P_NOT_SAFE_PRIME);
    eval 'sub DH_UNABLE_TO_CHECK_GENERATOR () {0x4;}' unless defined(&DH_UNABLE_TO_CHECK_GENERATOR);
    eval 'sub DH_NOT_SUITABLE_GENERATOR () {0x8;}' unless defined(&DH_NOT_SUITABLE_GENERATOR);
    eval 'sub DH_CHECK_PUBKEY_TOO_SMALL () {0x1;}' unless defined(&DH_CHECK_PUBKEY_TOO_SMALL);
    eval 'sub DH_CHECK_PUBKEY_TOO_LARGE () {0x2;}' unless defined(&DH_CHECK_PUBKEY_TOO_LARGE);
    eval 'sub DH_CHECK_P_NOT_STRONG_PRIME () { &DH_CHECK_P_NOT_SAFE_PRIME;}' unless defined(&DH_CHECK_P_NOT_STRONG_PRIME);
    eval 'sub d2i_DHparams_fp {
        my($fp,$x) = @_;
	    eval q(( &DH *) &ASN1_d2i_fp((\'char\' *(*)()) &DH_new, (\'char\' *(*)()) &d2i_DHparams,,($x)));
    }' unless defined(&d2i_DHparams_fp);
    eval 'sub i2d_DHparams_fp {
        my($fp,$x) = @_;
	    eval q( &ASN1_i2d_fp( &i2d_DHparams,, ($x)));
    }' unless defined(&i2d_DHparams_fp);
    eval 'sub d2i_DHparams_bio {
        my($bp,$x) = @_;
	    eval q( &ASN1_d2i_bio_of( &DH, &DH_new, &d2i_DHparams,$bp,$x));
    }' unless defined(&d2i_DHparams_bio);
    eval 'sub i2d_DHparams_bio {
        my($bp,$x) = @_;
	    eval q( &ASN1_i2d_bio_of_const( &DH, &i2d_DHparams,$bp,$x));
    }' unless defined(&i2d_DHparams_bio);
    unless(defined(&OPENSSL_NO_DEPRECATED)) {
    }
    unless(defined(&OPENSSL_NO_FP_API)) {
    }
    unless(defined(&OPENSSL_NO_BIO)) {
    } else {
    }
    eval 'sub EVP_PKEY_CTX_set_dh_paramgen_prime_len {
        my($ctx, $len) = @_;
	    eval q( &EVP_PKEY_CTX_ctrl($ctx,  &EVP_PKEY_DH,  &EVP_PKEY_OP_PARAMGEN,  &EVP_PKEY_CTRL_DH_PARAMGEN_PRIME_LEN, $len,  &NULL));
    }' unless defined(&EVP_PKEY_CTX_set_dh_paramgen_prime_len);
    eval 'sub EVP_PKEY_CTX_set_dh_paramgen_generator {
        my($ctx, $gen) = @_;
	    eval q( &EVP_PKEY_CTX_ctrl($ctx,  &EVP_PKEY_DH,  &EVP_PKEY_OP_PARAMGEN,  &EVP_PKEY_CTRL_DH_PARAMGEN_GENERATOR, $gen,  &NULL));
    }' unless defined(&EVP_PKEY_CTX_set_dh_paramgen_generator);
    eval 'sub EVP_PKEY_CTRL_DH_PARAMGEN_PRIME_LEN () {( &EVP_PKEY_ALG_CTRL + 1);}' unless defined(&EVP_PKEY_CTRL_DH_PARAMGEN_PRIME_LEN);
    eval 'sub EVP_PKEY_CTRL_DH_PARAMGEN_GENERATOR () {( &EVP_PKEY_ALG_CTRL + 2);}' unless defined(&EVP_PKEY_CTRL_DH_PARAMGEN_GENERATOR);
    eval 'sub DH_F_COMPUTE_KEY () {102;}' unless defined(&DH_F_COMPUTE_KEY);
    eval 'sub DH_F_DHPARAMS_PRINT_FP () {101;}' unless defined(&DH_F_DHPARAMS_PRINT_FP);
    eval 'sub DH_F_DH_BUILTIN_GENPARAMS () {106;}' unless defined(&DH_F_DH_BUILTIN_GENPARAMS);
    eval 'sub DH_F_DH_NEW_METHOD () {105;}' unless defined(&DH_F_DH_NEW_METHOD);
    eval 'sub DH_F_DH_PARAM_DECODE () {107;}' unless defined(&DH_F_DH_PARAM_DECODE);
    eval 'sub DH_F_DH_PRIV_DECODE () {110;}' unless defined(&DH_F_DH_PRIV_DECODE);
    eval 'sub DH_F_DH_PRIV_ENCODE () {111;}' unless defined(&DH_F_DH_PRIV_ENCODE);
    eval 'sub DH_F_DH_PUB_DECODE () {108;}' unless defined(&DH_F_DH_PUB_DECODE);
    eval 'sub DH_F_DH_PUB_ENCODE () {109;}' unless defined(&DH_F_DH_PUB_ENCODE);
    eval 'sub DH_F_DO_DH_PRINT () {100;}' unless defined(&DH_F_DO_DH_PRINT);
    eval 'sub DH_F_GENERATE_KEY () {103;}' unless defined(&DH_F_GENERATE_KEY);
    eval 'sub DH_F_GENERATE_PARAMETERS () {104;}' unless defined(&DH_F_GENERATE_PARAMETERS);
    eval 'sub DH_F_PKEY_DH_DERIVE () {112;}' unless defined(&DH_F_PKEY_DH_DERIVE);
    eval 'sub DH_F_PKEY_DH_KEYGEN () {113;}' unless defined(&DH_F_PKEY_DH_KEYGEN);
    eval 'sub DH_R_BAD_GENERATOR () {101;}' unless defined(&DH_R_BAD_GENERATOR);
    eval 'sub DH_R_BN_DECODE_ERROR () {109;}' unless defined(&DH_R_BN_DECODE_ERROR);
    eval 'sub DH_R_BN_ERROR () {106;}' unless defined(&DH_R_BN_ERROR);
    eval 'sub DH_R_DECODE_ERROR () {104;}' unless defined(&DH_R_DECODE_ERROR);
    eval 'sub DH_R_INVALID_PUBKEY () {102;}' unless defined(&DH_R_INVALID_PUBKEY);
    eval 'sub DH_R_KEYS_NOT_SET () {108;}' unless defined(&DH_R_KEYS_NOT_SET);
    eval 'sub DH_R_MODULUS_TOO_LARGE () {103;}' unless defined(&DH_R_MODULUS_TOO_LARGE);
    eval 'sub DH_R_NO_PARAMETERS_SET () {107;}' unless defined(&DH_R_NO_PARAMETERS_SET);
    eval 'sub DH_R_NO_PRIVATE_VALUE () {100;}' unless defined(&DH_R_NO_PRIVATE_VALUE);
    eval 'sub DH_R_PARAMETER_ENCODING_ERROR () {105;}' unless defined(&DH_R_PARAMETER_ENCODING_ERROR);
    if(defined(&__cplusplus)) {
    }
}
1;
