require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&HEADER_ERR_H)) {
    eval 'sub HEADER_ERR_H () {1;}' unless defined(&HEADER_ERR_H);
    require 'openssl/e_os2.ph';
    unless(defined(&OPENSSL_NO_FP_API)) {
	require 'stdio.ph';
	require 'stdlib.ph';
    }
    require 'openssl/ossl_typ.ph';
    unless(defined(&OPENSSL_NO_BIO)) {
	require 'openssl/bio.ph';
    }
    unless(defined(&OPENSSL_NO_LHASH)) {
	require 'openssl/lhash.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&OPENSSL_NO_ERR)) {
	eval 'sub ERR_PUT_error {
	    my($a,$b,$c,$d,$e) = @_;
    	    eval q( &ERR_put_error($a,$b,$c,$d,$e));
	}' unless defined(&ERR_PUT_error);
    } else {
	eval 'sub ERR_PUT_error {
	    my($a,$b,$c,$d,$e) = @_;
    	    eval q( &ERR_put_error($a,$b,$c, &NULL,0));
	}' unless defined(&ERR_PUT_error);
    }
    require 'errno.ph';
    eval 'sub ERR_TXT_MALLOCED () {0x1;}' unless defined(&ERR_TXT_MALLOCED);
    eval 'sub ERR_TXT_STRING () {0x2;}' unless defined(&ERR_TXT_STRING);
    eval 'sub ERR_FLAG_MARK () {0x1;}' unless defined(&ERR_FLAG_MARK);
    eval 'sub ERR_NUM_ERRORS () {16;}' unless defined(&ERR_NUM_ERRORS);
    eval 'sub ERR_LIB_NONE () {1;}' unless defined(&ERR_LIB_NONE);
    eval 'sub ERR_LIB_SYS () {2;}' unless defined(&ERR_LIB_SYS);
    eval 'sub ERR_LIB_BN () {3;}' unless defined(&ERR_LIB_BN);
    eval 'sub ERR_LIB_RSA () {4;}' unless defined(&ERR_LIB_RSA);
    eval 'sub ERR_LIB_DH () {5;}' unless defined(&ERR_LIB_DH);
    eval 'sub ERR_LIB_EVP () {6;}' unless defined(&ERR_LIB_EVP);
    eval 'sub ERR_LIB_BUF () {7;}' unless defined(&ERR_LIB_BUF);
    eval 'sub ERR_LIB_OBJ () {8;}' unless defined(&ERR_LIB_OBJ);
    eval 'sub ERR_LIB_PEM () {9;}' unless defined(&ERR_LIB_PEM);
    eval 'sub ERR_LIB_DSA () {10;}' unless defined(&ERR_LIB_DSA);
    eval 'sub ERR_LIB_X509 () {11;}' unless defined(&ERR_LIB_X509);
    eval 'sub ERR_LIB_ASN1 () {13;}' unless defined(&ERR_LIB_ASN1);
    eval 'sub ERR_LIB_CONF () {14;}' unless defined(&ERR_LIB_CONF);
    eval 'sub ERR_LIB_CRYPTO () {15;}' unless defined(&ERR_LIB_CRYPTO);
    eval 'sub ERR_LIB_EC () {16;}' unless defined(&ERR_LIB_EC);
    eval 'sub ERR_LIB_SSL () {20;}' unless defined(&ERR_LIB_SSL);
    eval 'sub ERR_LIB_BIO () {32;}' unless defined(&ERR_LIB_BIO);
    eval 'sub ERR_LIB_PKCS7 () {33;}' unless defined(&ERR_LIB_PKCS7);
    eval 'sub ERR_LIB_X509V3 () {34;}' unless defined(&ERR_LIB_X509V3);
    eval 'sub ERR_LIB_PKCS12 () {35;}' unless defined(&ERR_LIB_PKCS12);
    eval 'sub ERR_LIB_RAND () {36;}' unless defined(&ERR_LIB_RAND);
    eval 'sub ERR_LIB_DSO () {37;}' unless defined(&ERR_LIB_DSO);
    eval 'sub ERR_LIB_ENGINE () {38;}' unless defined(&ERR_LIB_ENGINE);
    eval 'sub ERR_LIB_OCSP () {39;}' unless defined(&ERR_LIB_OCSP);
    eval 'sub ERR_LIB_UI () {40;}' unless defined(&ERR_LIB_UI);
    eval 'sub ERR_LIB_COMP () {41;}' unless defined(&ERR_LIB_COMP);
    eval 'sub ERR_LIB_ECDSA () {42;}' unless defined(&ERR_LIB_ECDSA);
    eval 'sub ERR_LIB_ECDH () {43;}' unless defined(&ERR_LIB_ECDH);
    eval 'sub ERR_LIB_STORE () {44;}' unless defined(&ERR_LIB_STORE);
    eval 'sub ERR_LIB_FIPS () {45;}' unless defined(&ERR_LIB_FIPS);
    eval 'sub ERR_LIB_CMS () {46;}' unless defined(&ERR_LIB_CMS);
    eval 'sub ERR_LIB_TS () {47;}' unless defined(&ERR_LIB_TS);
    eval 'sub ERR_LIB_HMAC () {48;}' unless defined(&ERR_LIB_HMAC);
    eval 'sub ERR_LIB_JPAKE () {49;}' unless defined(&ERR_LIB_JPAKE);
    eval 'sub ERR_LIB_USER () {128;}' unless defined(&ERR_LIB_USER);
    eval 'sub SYSerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_SYS,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&SYSerr);
    eval 'sub BNerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_BN,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&BNerr);
    eval 'sub RSAerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_RSA,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&RSAerr);
    eval 'sub DHerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_DH,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&DHerr);
    eval 'sub EVPerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_EVP,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&EVPerr);
    eval 'sub BUFerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_BUF,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&BUFerr);
    eval 'sub OBJerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_OBJ,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&OBJerr);
    eval 'sub PEMerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_PEM,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&PEMerr);
    eval 'sub DSAerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_DSA,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&DSAerr);
    eval 'sub X509err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_X509,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&X509err);
    eval 'sub ASN1err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_ASN1,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&ASN1err);
    eval 'sub CONFerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_CONF,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&CONFerr);
    eval 'sub CRYPTOerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_CRYPTO,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&CRYPTOerr);
    eval 'sub ECerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_EC,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&ECerr);
    eval 'sub SSLerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_SSL,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&SSLerr);
    eval 'sub BIOerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_BIO,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&BIOerr);
    eval 'sub PKCS7err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_PKCS7,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&PKCS7err);
    eval 'sub X509V3err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_X509V3,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&X509V3err);
    eval 'sub PKCS12err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_PKCS12,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&PKCS12err);
    eval 'sub RANDerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_RAND,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&RANDerr);
    eval 'sub DSOerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_DSO,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&DSOerr);
    eval 'sub ENGINEerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_ENGINE,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&ENGINEerr);
    eval 'sub OCSPerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_OCSP,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&OCSPerr);
    eval 'sub UIerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_UI,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&UIerr);
    eval 'sub COMPerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_COMP,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&COMPerr);
    eval 'sub ECDSAerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_ECDSA,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&ECDSAerr);
    eval 'sub ECDHerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_ECDH,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&ECDHerr);
    eval 'sub STOREerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_STORE,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&STOREerr);
    eval 'sub FIPSerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_FIPS,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&FIPSerr);
    eval 'sub CMSerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_CMS,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&CMSerr);
    eval 'sub TSerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_TS,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&TSerr);
    eval 'sub HMACerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_HMAC,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&HMACerr);
    eval 'sub JPAKEerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_JPAKE,($f),($r), &__FILE__, &__LINE__));
    }' unless defined(&JPAKEerr);
    eval 'sub ERR_PACK {
        my($l,$f,$r) = @_;
	    eval q((((&0xff)*0x1000000)| ((&0xfff)*0x1000)| ((($r)&0xfff))));
    }' unless defined(&ERR_PACK);
    eval 'sub ERR_GET_LIB {
        my($l) = @_;
	    eval q(((($l)>>24)&0xff));
    }' unless defined(&ERR_GET_LIB);
    eval 'sub ERR_GET_FUNC {
        my($l) = @_;
	    eval q(((($l)>>12)&0xfff));
    }' unless defined(&ERR_GET_FUNC);
    eval 'sub ERR_GET_REASON {
        my($l) = @_;
	    eval q((($l)&0xfff));
    }' unless defined(&ERR_GET_REASON);
    eval 'sub ERR_FATAL_ERROR {
        my($l) = @_;
	    eval q((($l) &ERR_R_FATAL));
    }' unless defined(&ERR_FATAL_ERROR);
    eval 'sub SYS_F_FOPEN () {1;}' unless defined(&SYS_F_FOPEN);
    eval 'sub SYS_F_CONNECT () {2;}' unless defined(&SYS_F_CONNECT);
    eval 'sub SYS_F_GETSERVBYNAME () {3;}' unless defined(&SYS_F_GETSERVBYNAME);
    eval 'sub SYS_F_SOCKET () {4;}' unless defined(&SYS_F_SOCKET);
    eval 'sub SYS_F_IOCTLSOCKET () {5;}' unless defined(&SYS_F_IOCTLSOCKET);
    eval 'sub SYS_F_BIND () {6;}' unless defined(&SYS_F_BIND);
    eval 'sub SYS_F_LISTEN () {7;}' unless defined(&SYS_F_LISTEN);
    eval 'sub SYS_F_ACCEPT () {8;}' unless defined(&SYS_F_ACCEPT);
    eval 'sub SYS_F_WSASTARTUP () {9;}' unless defined(&SYS_F_WSASTARTUP);
    eval 'sub SYS_F_OPENDIR () {10;}' unless defined(&SYS_F_OPENDIR);
    eval 'sub SYS_F_FREAD () {11;}' unless defined(&SYS_F_FREAD);
    eval 'sub ERR_R_SYS_LIB () { &ERR_LIB_SYS;}' unless defined(&ERR_R_SYS_LIB);
    eval 'sub ERR_R_BN_LIB () { &ERR_LIB_BN;}' unless defined(&ERR_R_BN_LIB);
    eval 'sub ERR_R_RSA_LIB () { &ERR_LIB_RSA;}' unless defined(&ERR_R_RSA_LIB);
    eval 'sub ERR_R_DH_LIB () { &ERR_LIB_DH;}' unless defined(&ERR_R_DH_LIB);
    eval 'sub ERR_R_EVP_LIB () { &ERR_LIB_EVP;}' unless defined(&ERR_R_EVP_LIB);
    eval 'sub ERR_R_BUF_LIB () { &ERR_LIB_BUF;}' unless defined(&ERR_R_BUF_LIB);
    eval 'sub ERR_R_OBJ_LIB () { &ERR_LIB_OBJ;}' unless defined(&ERR_R_OBJ_LIB);
    eval 'sub ERR_R_PEM_LIB () { &ERR_LIB_PEM;}' unless defined(&ERR_R_PEM_LIB);
    eval 'sub ERR_R_DSA_LIB () { &ERR_LIB_DSA;}' unless defined(&ERR_R_DSA_LIB);
    eval 'sub ERR_R_X509_LIB () { &ERR_LIB_X509;}' unless defined(&ERR_R_X509_LIB);
    eval 'sub ERR_R_ASN1_LIB () { &ERR_LIB_ASN1;}' unless defined(&ERR_R_ASN1_LIB);
    eval 'sub ERR_R_CONF_LIB () { &ERR_LIB_CONF;}' unless defined(&ERR_R_CONF_LIB);
    eval 'sub ERR_R_CRYPTO_LIB () { &ERR_LIB_CRYPTO;}' unless defined(&ERR_R_CRYPTO_LIB);
    eval 'sub ERR_R_EC_LIB () { &ERR_LIB_EC;}' unless defined(&ERR_R_EC_LIB);
    eval 'sub ERR_R_SSL_LIB () { &ERR_LIB_SSL;}' unless defined(&ERR_R_SSL_LIB);
    eval 'sub ERR_R_BIO_LIB () { &ERR_LIB_BIO;}' unless defined(&ERR_R_BIO_LIB);
    eval 'sub ERR_R_PKCS7_LIB () { &ERR_LIB_PKCS7;}' unless defined(&ERR_R_PKCS7_LIB);
    eval 'sub ERR_R_X509V3_LIB () { &ERR_LIB_X509V3;}' unless defined(&ERR_R_X509V3_LIB);
    eval 'sub ERR_R_PKCS12_LIB () { &ERR_LIB_PKCS12;}' unless defined(&ERR_R_PKCS12_LIB);
    eval 'sub ERR_R_RAND_LIB () { &ERR_LIB_RAND;}' unless defined(&ERR_R_RAND_LIB);
    eval 'sub ERR_R_DSO_LIB () { &ERR_LIB_DSO;}' unless defined(&ERR_R_DSO_LIB);
    eval 'sub ERR_R_ENGINE_LIB () { &ERR_LIB_ENGINE;}' unless defined(&ERR_R_ENGINE_LIB);
    eval 'sub ERR_R_OCSP_LIB () { &ERR_LIB_OCSP;}' unless defined(&ERR_R_OCSP_LIB);
    eval 'sub ERR_R_UI_LIB () { &ERR_LIB_UI;}' unless defined(&ERR_R_UI_LIB);
    eval 'sub ERR_R_COMP_LIB () { &ERR_LIB_COMP;}' unless defined(&ERR_R_COMP_LIB);
    eval 'sub ERR_R_ECDSA_LIB () { &ERR_LIB_ECDSA;}' unless defined(&ERR_R_ECDSA_LIB);
    eval 'sub ERR_R_ECDH_LIB () { &ERR_LIB_ECDH;}' unless defined(&ERR_R_ECDH_LIB);
    eval 'sub ERR_R_STORE_LIB () { &ERR_LIB_STORE;}' unless defined(&ERR_R_STORE_LIB);
    eval 'sub ERR_R_TS_LIB () { &ERR_LIB_TS;}' unless defined(&ERR_R_TS_LIB);
    eval 'sub ERR_R_NESTED_ASN1_ERROR () {58;}' unless defined(&ERR_R_NESTED_ASN1_ERROR);
    eval 'sub ERR_R_BAD_ASN1_OBJECT_HEADER () {59;}' unless defined(&ERR_R_BAD_ASN1_OBJECT_HEADER);
    eval 'sub ERR_R_BAD_GET_ASN1_OBJECT_CALL () {60;}' unless defined(&ERR_R_BAD_GET_ASN1_OBJECT_CALL);
    eval 'sub ERR_R_EXPECTING_AN_ASN1_SEQUENCE () {61;}' unless defined(&ERR_R_EXPECTING_AN_ASN1_SEQUENCE);
    eval 'sub ERR_R_ASN1_LENGTH_MISMATCH () {62;}' unless defined(&ERR_R_ASN1_LENGTH_MISMATCH);
    eval 'sub ERR_R_MISSING_ASN1_EOS () {63;}' unless defined(&ERR_R_MISSING_ASN1_EOS);
    eval 'sub ERR_R_FATAL () {64;}' unless defined(&ERR_R_FATAL);
    eval 'sub ERR_R_MALLOC_FAILURE () {(1| &ERR_R_FATAL);}' unless defined(&ERR_R_MALLOC_FAILURE);
    eval 'sub ERR_R_SHOULD_NOT_HAVE_BEEN_CALLED () {(2| &ERR_R_FATAL);}' unless defined(&ERR_R_SHOULD_NOT_HAVE_BEEN_CALLED);
    eval 'sub ERR_R_PASSED_NULL_PARAMETER () {(3| &ERR_R_FATAL);}' unless defined(&ERR_R_PASSED_NULL_PARAMETER);
    eval 'sub ERR_R_INTERNAL_ERROR () {(4| &ERR_R_FATAL);}' unless defined(&ERR_R_INTERNAL_ERROR);
    eval 'sub ERR_R_DISABLED () {(5| &ERR_R_FATAL);}' unless defined(&ERR_R_DISABLED);
    unless(defined(&OPENSSL_NO_FP_API)) {
    }
    unless(defined(&OPENSSL_NO_BIO)) {
    }
    unless(defined(&OPENSSL_NO_DEPRECATED)) {
    }
    unless(defined(&OPENSSL_NO_LHASH)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
