require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&HEADER_PKCS7_H)) {
    eval 'sub HEADER_PKCS7_H () {1;}' unless defined(&HEADER_PKCS7_H);
    require 'openssl/asn1.ph';
    require 'openssl/bio.ph';
    require 'openssl/e_os2.ph';
    require 'openssl/symhacks.ph';
    require 'openssl/ossl_typ.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&OPENSSL_SYS_WIN32)) {
	undef(&PKCS7_ISSUER_AND_SERIAL) if defined(&PKCS7_ISSUER_AND_SERIAL);
	undef(&PKCS7_SIGNER_INFO) if defined(&PKCS7_SIGNER_INFO);
    }
    eval 'sub PKCS7_S_HEADER () {0;}' unless defined(&PKCS7_S_HEADER);
    eval 'sub PKCS7_S_BODY () {1;}' unless defined(&PKCS7_S_BODY);
    eval 'sub PKCS7_S_TAIL () {2;}' unless defined(&PKCS7_S_TAIL);
    eval 'sub PKCS7_OP_SET_DETACHED_SIGNATURE () {1;}' unless defined(&PKCS7_OP_SET_DETACHED_SIGNATURE);
    eval 'sub PKCS7_OP_GET_DETACHED_SIGNATURE () {2;}' unless defined(&PKCS7_OP_GET_DETACHED_SIGNATURE);
    eval 'sub PKCS7_get_signed_attributes {
        my($si) = @_;
	    eval q((($si)-> &auth_attr));
    }' unless defined(&PKCS7_get_signed_attributes);
    eval 'sub PKCS7_get_attributes {
        my($si) = @_;
	    eval q((($si)-> &unauth_attr));
    }' unless defined(&PKCS7_get_attributes);
    eval 'sub PKCS7_type_is_signed {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_signed));
    }' unless defined(&PKCS7_type_is_signed);
    eval 'sub PKCS7_type_is_encrypted {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_encrypted));
    }' unless defined(&PKCS7_type_is_encrypted);
    eval 'sub PKCS7_type_is_enveloped {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_enveloped));
    }' unless defined(&PKCS7_type_is_enveloped);
    eval 'sub PKCS7_type_is_signedAndEnveloped {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_signedAndEnveloped));
    }' unless defined(&PKCS7_type_is_signedAndEnveloped);
    eval 'sub PKCS7_type_is_data {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_data));
    }' unless defined(&PKCS7_type_is_data);
    eval 'sub PKCS7_type_is_digest {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_digest));
    }' unless defined(&PKCS7_type_is_digest);
    eval 'sub PKCS7_type_is_encrypted {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_encrypted));
    }' unless defined(&PKCS7_type_is_encrypted);
    eval 'sub PKCS7_type_is_digest {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_digest));
    }' unless defined(&PKCS7_type_is_digest);
    eval 'sub PKCS7_set_detached {
        my($p,$v) = @_;
	    eval q( &PKCS7_ctrl($p, &PKCS7_OP_SET_DETACHED_SIGNATURE,$v, &NULL));
    }' unless defined(&PKCS7_set_detached);
    eval 'sub PKCS7_get_detached {
        my($p) = @_;
	    eval q( &PKCS7_ctrl($p, &PKCS7_OP_GET_DETACHED_SIGNATURE,0, &NULL));
    }' unless defined(&PKCS7_get_detached);
    eval 'sub PKCS7_is_detached {
        my($p7) = @_;
	    eval q(( &PKCS7_type_is_signed($p7)  &&  &PKCS7_get_detached($p7)));
    }' unless defined(&PKCS7_is_detached);
    eval 'sub PKCS7_TEXT () {0x1;}' unless defined(&PKCS7_TEXT);
    eval 'sub PKCS7_NOCERTS () {0x2;}' unless defined(&PKCS7_NOCERTS);
    eval 'sub PKCS7_NOSIGS () {0x4;}' unless defined(&PKCS7_NOSIGS);
    eval 'sub PKCS7_NOCHAIN () {0x8;}' unless defined(&PKCS7_NOCHAIN);
    eval 'sub PKCS7_NOINTERN () {0x10;}' unless defined(&PKCS7_NOINTERN);
    eval 'sub PKCS7_NOVERIFY () {0x20;}' unless defined(&PKCS7_NOVERIFY);
    eval 'sub PKCS7_DETACHED () {0x40;}' unless defined(&PKCS7_DETACHED);
    eval 'sub PKCS7_BINARY () {0x80;}' unless defined(&PKCS7_BINARY);
    eval 'sub PKCS7_NOATTR () {0x100;}' unless defined(&PKCS7_NOATTR);
    eval 'sub PKCS7_NOSMIMECAP () {0x200;}' unless defined(&PKCS7_NOSMIMECAP);
    eval 'sub PKCS7_NOOLDMIMETYPE () {0x400;}' unless defined(&PKCS7_NOOLDMIMETYPE);
    eval 'sub PKCS7_CRLFEOL () {0x800;}' unless defined(&PKCS7_CRLFEOL);
    eval 'sub PKCS7_STREAM () {0x1000;}' unless defined(&PKCS7_STREAM);
    eval 'sub PKCS7_NOCRL () {0x2000;}' unless defined(&PKCS7_NOCRL);
    eval 'sub PKCS7_PARTIAL () {0x4000;}' unless defined(&PKCS7_PARTIAL);
    eval 'sub PKCS7_REUSE_DIGEST () {0x8000;}' unless defined(&PKCS7_REUSE_DIGEST);
    eval 'sub SMIME_TEXT () { &PKCS7_TEXT;}' unless defined(&SMIME_TEXT);
    eval 'sub SMIME_NOCERTS () { &PKCS7_NOCERTS;}' unless defined(&SMIME_NOCERTS);
    eval 'sub SMIME_NOSIGS () { &PKCS7_NOSIGS;}' unless defined(&SMIME_NOSIGS);
    eval 'sub SMIME_NOCHAIN () { &PKCS7_NOCHAIN;}' unless defined(&SMIME_NOCHAIN);
    eval 'sub SMIME_NOINTERN () { &PKCS7_NOINTERN;}' unless defined(&SMIME_NOINTERN);
    eval 'sub SMIME_NOVERIFY () { &PKCS7_NOVERIFY;}' unless defined(&SMIME_NOVERIFY);
    eval 'sub SMIME_DETACHED () { &PKCS7_DETACHED;}' unless defined(&SMIME_DETACHED);
    eval 'sub SMIME_BINARY () { &PKCS7_BINARY;}' unless defined(&SMIME_BINARY);
    eval 'sub SMIME_NOATTR () { &PKCS7_NOATTR;}' unless defined(&SMIME_NOATTR);
    unless(defined(&OPENSSL_NO_FP_API)) {
    }
    eval 'sub PKCS7_F_B64_READ_PKCS7 () {120;}' unless defined(&PKCS7_F_B64_READ_PKCS7);
    eval 'sub PKCS7_F_B64_WRITE_PKCS7 () {121;}' unless defined(&PKCS7_F_B64_WRITE_PKCS7);
    eval 'sub PKCS7_F_DO_PKCS7_SIGNED_ATTRIB () {136;}' unless defined(&PKCS7_F_DO_PKCS7_SIGNED_ATTRIB);
    eval 'sub PKCS7_F_I2D_PKCS7_BIO_STREAM () {140;}' unless defined(&PKCS7_F_I2D_PKCS7_BIO_STREAM);
    eval 'sub PKCS7_F_PKCS7_ADD0_ATTRIB_SIGNING_TIME () {135;}' unless defined(&PKCS7_F_PKCS7_ADD0_ATTRIB_SIGNING_TIME);
    eval 'sub PKCS7_F_PKCS7_ADD_ATTRIB_SMIMECAP () {118;}' unless defined(&PKCS7_F_PKCS7_ADD_ATTRIB_SMIMECAP);
    eval 'sub PKCS7_F_PKCS7_ADD_CERTIFICATE () {100;}' unless defined(&PKCS7_F_PKCS7_ADD_CERTIFICATE);
    eval 'sub PKCS7_F_PKCS7_ADD_CRL () {101;}' unless defined(&PKCS7_F_PKCS7_ADD_CRL);
    eval 'sub PKCS7_F_PKCS7_ADD_RECIPIENT_INFO () {102;}' unless defined(&PKCS7_F_PKCS7_ADD_RECIPIENT_INFO);
    eval 'sub PKCS7_F_PKCS7_ADD_SIGNATURE () {131;}' unless defined(&PKCS7_F_PKCS7_ADD_SIGNATURE);
    eval 'sub PKCS7_F_PKCS7_ADD_SIGNER () {103;}' unless defined(&PKCS7_F_PKCS7_ADD_SIGNER);
    eval 'sub PKCS7_F_PKCS7_BIO_ADD_DIGEST () {125;}' unless defined(&PKCS7_F_PKCS7_BIO_ADD_DIGEST);
    eval 'sub PKCS7_F_PKCS7_COPY_EXISTING_DIGEST () {138;}' unless defined(&PKCS7_F_PKCS7_COPY_EXISTING_DIGEST);
    eval 'sub PKCS7_F_PKCS7_CTRL () {104;}' unless defined(&PKCS7_F_PKCS7_CTRL);
    eval 'sub PKCS7_F_PKCS7_DATADECODE () {112;}' unless defined(&PKCS7_F_PKCS7_DATADECODE);
    eval 'sub PKCS7_F_PKCS7_DATAFINAL () {128;}' unless defined(&PKCS7_F_PKCS7_DATAFINAL);
    eval 'sub PKCS7_F_PKCS7_DATAINIT () {105;}' unless defined(&PKCS7_F_PKCS7_DATAINIT);
    eval 'sub PKCS7_F_PKCS7_DATASIGN () {106;}' unless defined(&PKCS7_F_PKCS7_DATASIGN);
    eval 'sub PKCS7_F_PKCS7_DATAVERIFY () {107;}' unless defined(&PKCS7_F_PKCS7_DATAVERIFY);
    eval 'sub PKCS7_F_PKCS7_DECRYPT () {114;}' unless defined(&PKCS7_F_PKCS7_DECRYPT);
    eval 'sub PKCS7_F_PKCS7_DECRYPT_RINFO () {133;}' unless defined(&PKCS7_F_PKCS7_DECRYPT_RINFO);
    eval 'sub PKCS7_F_PKCS7_ENCODE_RINFO () {132;}' unless defined(&PKCS7_F_PKCS7_ENCODE_RINFO);
    eval 'sub PKCS7_F_PKCS7_ENCRYPT () {115;}' unless defined(&PKCS7_F_PKCS7_ENCRYPT);
    eval 'sub PKCS7_F_PKCS7_FINAL () {134;}' unless defined(&PKCS7_F_PKCS7_FINAL);
    eval 'sub PKCS7_F_PKCS7_FIND_DIGEST () {127;}' unless defined(&PKCS7_F_PKCS7_FIND_DIGEST);
    eval 'sub PKCS7_F_PKCS7_GET0_SIGNERS () {124;}' unless defined(&PKCS7_F_PKCS7_GET0_SIGNERS);
    eval 'sub PKCS7_F_PKCS7_RECIP_INFO_SET () {130;}' unless defined(&PKCS7_F_PKCS7_RECIP_INFO_SET);
    eval 'sub PKCS7_F_PKCS7_SET_CIPHER () {108;}' unless defined(&PKCS7_F_PKCS7_SET_CIPHER);
    eval 'sub PKCS7_F_PKCS7_SET_CONTENT () {109;}' unless defined(&PKCS7_F_PKCS7_SET_CONTENT);
    eval 'sub PKCS7_F_PKCS7_SET_DIGEST () {126;}' unless defined(&PKCS7_F_PKCS7_SET_DIGEST);
    eval 'sub PKCS7_F_PKCS7_SET_TYPE () {110;}' unless defined(&PKCS7_F_PKCS7_SET_TYPE);
    eval 'sub PKCS7_F_PKCS7_SIGN () {116;}' unless defined(&PKCS7_F_PKCS7_SIGN);
    eval 'sub PKCS7_F_PKCS7_SIGNATUREVERIFY () {113;}' unless defined(&PKCS7_F_PKCS7_SIGNATUREVERIFY);
    eval 'sub PKCS7_F_PKCS7_SIGNER_INFO_SET () {129;}' unless defined(&PKCS7_F_PKCS7_SIGNER_INFO_SET);
    eval 'sub PKCS7_F_PKCS7_SIGNER_INFO_SIGN () {139;}' unless defined(&PKCS7_F_PKCS7_SIGNER_INFO_SIGN);
    eval 'sub PKCS7_F_PKCS7_SIGN_ADD_SIGNER () {137;}' unless defined(&PKCS7_F_PKCS7_SIGN_ADD_SIGNER);
    eval 'sub PKCS7_F_PKCS7_SIMPLE_SMIMECAP () {119;}' unless defined(&PKCS7_F_PKCS7_SIMPLE_SMIMECAP);
    eval 'sub PKCS7_F_PKCS7_VERIFY () {117;}' unless defined(&PKCS7_F_PKCS7_VERIFY);
    eval 'sub PKCS7_F_SMIME_READ_PKCS7 () {122;}' unless defined(&PKCS7_F_SMIME_READ_PKCS7);
    eval 'sub PKCS7_F_SMIME_TEXT () {123;}' unless defined(&PKCS7_F_SMIME_TEXT);
    eval 'sub PKCS7_R_CERTIFICATE_VERIFY_ERROR () {117;}' unless defined(&PKCS7_R_CERTIFICATE_VERIFY_ERROR);
    eval 'sub PKCS7_R_CIPHER_HAS_NO_OBJECT_IDENTIFIER () {144;}' unless defined(&PKCS7_R_CIPHER_HAS_NO_OBJECT_IDENTIFIER);
    eval 'sub PKCS7_R_CIPHER_NOT_INITIALIZED () {116;}' unless defined(&PKCS7_R_CIPHER_NOT_INITIALIZED);
    eval 'sub PKCS7_R_CONTENT_AND_DATA_PRESENT () {118;}' unless defined(&PKCS7_R_CONTENT_AND_DATA_PRESENT);
    eval 'sub PKCS7_R_CTRL_ERROR () {152;}' unless defined(&PKCS7_R_CTRL_ERROR);
    eval 'sub PKCS7_R_DECODE_ERROR () {130;}' unless defined(&PKCS7_R_DECODE_ERROR);
    eval 'sub PKCS7_R_DECRYPTED_KEY_IS_WRONG_LENGTH () {100;}' unless defined(&PKCS7_R_DECRYPTED_KEY_IS_WRONG_LENGTH);
    eval 'sub PKCS7_R_DECRYPT_ERROR () {119;}' unless defined(&PKCS7_R_DECRYPT_ERROR);
    eval 'sub PKCS7_R_DIGEST_FAILURE () {101;}' unless defined(&PKCS7_R_DIGEST_FAILURE);
    eval 'sub PKCS7_R_ENCRYPTION_CTRL_FAILURE () {149;}' unless defined(&PKCS7_R_ENCRYPTION_CTRL_FAILURE);
    eval 'sub PKCS7_R_ENCRYPTION_NOT_SUPPORTED_FOR_THIS_KEY_TYPE () {150;}' unless defined(&PKCS7_R_ENCRYPTION_NOT_SUPPORTED_FOR_THIS_KEY_TYPE);
    eval 'sub PKCS7_R_ERROR_ADDING_RECIPIENT () {120;}' unless defined(&PKCS7_R_ERROR_ADDING_RECIPIENT);
    eval 'sub PKCS7_R_ERROR_SETTING_CIPHER () {121;}' unless defined(&PKCS7_R_ERROR_SETTING_CIPHER);
    eval 'sub PKCS7_R_INVALID_MIME_TYPE () {131;}' unless defined(&PKCS7_R_INVALID_MIME_TYPE);
    eval 'sub PKCS7_R_INVALID_NULL_POINTER () {143;}' unless defined(&PKCS7_R_INVALID_NULL_POINTER);
    eval 'sub PKCS7_R_MIME_NO_CONTENT_TYPE () {132;}' unless defined(&PKCS7_R_MIME_NO_CONTENT_TYPE);
    eval 'sub PKCS7_R_MIME_PARSE_ERROR () {133;}' unless defined(&PKCS7_R_MIME_PARSE_ERROR);
    eval 'sub PKCS7_R_MIME_SIG_PARSE_ERROR () {134;}' unless defined(&PKCS7_R_MIME_SIG_PARSE_ERROR);
    eval 'sub PKCS7_R_MISSING_CERIPEND_INFO () {103;}' unless defined(&PKCS7_R_MISSING_CERIPEND_INFO);
    eval 'sub PKCS7_R_NO_CONTENT () {122;}' unless defined(&PKCS7_R_NO_CONTENT);
    eval 'sub PKCS7_R_NO_CONTENT_TYPE () {135;}' unless defined(&PKCS7_R_NO_CONTENT_TYPE);
    eval 'sub PKCS7_R_NO_DEFAULT_DIGEST () {151;}' unless defined(&PKCS7_R_NO_DEFAULT_DIGEST);
    eval 'sub PKCS7_R_NO_MATCHING_DIGEST_TYPE_FOUND () {154;}' unless defined(&PKCS7_R_NO_MATCHING_DIGEST_TYPE_FOUND);
    eval 'sub PKCS7_R_NO_MULTIPART_BODY_FAILURE () {136;}' unless defined(&PKCS7_R_NO_MULTIPART_BODY_FAILURE);
    eval 'sub PKCS7_R_NO_MULTIPART_BOUNDARY () {137;}' unless defined(&PKCS7_R_NO_MULTIPART_BOUNDARY);
    eval 'sub PKCS7_R_NO_RECIPIENT_MATCHES_CERTIFICATE () {115;}' unless defined(&PKCS7_R_NO_RECIPIENT_MATCHES_CERTIFICATE);
    eval 'sub PKCS7_R_NO_RECIPIENT_MATCHES_KEY () {146;}' unless defined(&PKCS7_R_NO_RECIPIENT_MATCHES_KEY);
    eval 'sub PKCS7_R_NO_SIGNATURES_ON_DATA () {123;}' unless defined(&PKCS7_R_NO_SIGNATURES_ON_DATA);
    eval 'sub PKCS7_R_NO_SIGNERS () {142;}' unless defined(&PKCS7_R_NO_SIGNERS);
    eval 'sub PKCS7_R_NO_SIG_CONTENT_TYPE () {138;}' unless defined(&PKCS7_R_NO_SIG_CONTENT_TYPE);
    eval 'sub PKCS7_R_OPERATION_NOT_SUPPORTED_ON_THIS_TYPE () {104;}' unless defined(&PKCS7_R_OPERATION_NOT_SUPPORTED_ON_THIS_TYPE);
    eval 'sub PKCS7_R_PKCS7_ADD_SIGNATURE_ERROR () {124;}' unless defined(&PKCS7_R_PKCS7_ADD_SIGNATURE_ERROR);
    eval 'sub PKCS7_R_PKCS7_ADD_SIGNER_ERROR () {153;}' unless defined(&PKCS7_R_PKCS7_ADD_SIGNER_ERROR);
    eval 'sub PKCS7_R_PKCS7_DATAFINAL () {126;}' unless defined(&PKCS7_R_PKCS7_DATAFINAL);
    eval 'sub PKCS7_R_PKCS7_DATAFINAL_ERROR () {125;}' unless defined(&PKCS7_R_PKCS7_DATAFINAL_ERROR);
    eval 'sub PKCS7_R_PKCS7_DATASIGN () {145;}' unless defined(&PKCS7_R_PKCS7_DATASIGN);
    eval 'sub PKCS7_R_PKCS7_PARSE_ERROR () {139;}' unless defined(&PKCS7_R_PKCS7_PARSE_ERROR);
    eval 'sub PKCS7_R_PKCS7_SIG_PARSE_ERROR () {140;}' unless defined(&PKCS7_R_PKCS7_SIG_PARSE_ERROR);
    eval 'sub PKCS7_R_PRIVATE_KEY_DOES_NOT_MATCH_CERTIFICATE () {127;}' unless defined(&PKCS7_R_PRIVATE_KEY_DOES_NOT_MATCH_CERTIFICATE);
    eval 'sub PKCS7_R_SIGNATURE_FAILURE () {105;}' unless defined(&PKCS7_R_SIGNATURE_FAILURE);
    eval 'sub PKCS7_R_SIGNER_CERTIFICATE_NOT_FOUND () {128;}' unless defined(&PKCS7_R_SIGNER_CERTIFICATE_NOT_FOUND);
    eval 'sub PKCS7_R_SIGNING_CTRL_FAILURE () {147;}' unless defined(&PKCS7_R_SIGNING_CTRL_FAILURE);
    eval 'sub PKCS7_R_SIGNING_NOT_SUPPORTED_FOR_THIS_KEY_TYPE () {148;}' unless defined(&PKCS7_R_SIGNING_NOT_SUPPORTED_FOR_THIS_KEY_TYPE);
    eval 'sub PKCS7_R_SIG_INVALID_MIME_TYPE () {141;}' unless defined(&PKCS7_R_SIG_INVALID_MIME_TYPE);
    eval 'sub PKCS7_R_SMIME_TEXT_ERROR () {129;}' unless defined(&PKCS7_R_SMIME_TEXT_ERROR);
    eval 'sub PKCS7_R_UNABLE_TO_FIND_CERTIFICATE () {106;}' unless defined(&PKCS7_R_UNABLE_TO_FIND_CERTIFICATE);
    eval 'sub PKCS7_R_UNABLE_TO_FIND_MEM_BIO () {107;}' unless defined(&PKCS7_R_UNABLE_TO_FIND_MEM_BIO);
    eval 'sub PKCS7_R_UNABLE_TO_FIND_MESSAGE_DIGEST () {108;}' unless defined(&PKCS7_R_UNABLE_TO_FIND_MESSAGE_DIGEST);
    eval 'sub PKCS7_R_UNKNOWN_DIGEST_TYPE () {109;}' unless defined(&PKCS7_R_UNKNOWN_DIGEST_TYPE);
    eval 'sub PKCS7_R_UNKNOWN_OPERATION () {110;}' unless defined(&PKCS7_R_UNKNOWN_OPERATION);
    eval 'sub PKCS7_R_UNSUPPORTED_CIPHER_TYPE () {111;}' unless defined(&PKCS7_R_UNSUPPORTED_CIPHER_TYPE);
    eval 'sub PKCS7_R_UNSUPPORTED_CONTENT_TYPE () {112;}' unless defined(&PKCS7_R_UNSUPPORTED_CONTENT_TYPE);
    eval 'sub PKCS7_R_WRONG_CONTENT_TYPE () {113;}' unless defined(&PKCS7_R_WRONG_CONTENT_TYPE);
    eval 'sub PKCS7_R_WRONG_PKCS7_TYPE () {114;}' unless defined(&PKCS7_R_WRONG_PKCS7_TYPE);
    if(defined(&__cplusplus)) {
    }
}
1;
