require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&KTROP_SET)) {
    sub KTROP_SET () {	0;}
}
unless(defined(&KTROP_CLEAR)) {
    sub KTROP_CLEAR () {	1;}
}
unless(defined(&KTROP_CLEARFILE)) {
    sub KTROP_CLEARFILE () {	2;}
}
unless(defined(&KTROP)) {
    sub KTROP {
	my($o) = @_;
	eval q((($o)&3));
    }
}
unless(defined(&KTRFLAG_DESCEND)) {
    sub KTRFLAG_DESCEND () {	4;}
}
unless(defined(&KTRPOINT)) {
    sub KTRPOINT {
	my($p, $type) = @_;
	eval q((($p)-> ($p_p->{ps_traceflag}) & (1<<($type))  && (($p)-> &p_flag &  &P_INKTR) == 0));
    }
}
unless(defined(&KTR_START)) {
    sub KTR_START () {	0x4b545200;}
}
unless(defined(&KTR_SYSCALL)) {
    sub KTR_SYSCALL () {	1;}
}
unless(defined(&KTR_SYSRET)) {
    sub KTR_SYSRET () {	2;}
}
unless(defined(&KTR_NAMEI)) {
    sub KTR_NAMEI () {	3;}
}
unless(defined(&KTR_GENIO)) {
    sub KTR_GENIO () {	4;}
}
unless(defined(&KTR_PSIG)) {
    sub KTR_PSIG () {	5;}
}
unless(defined(&KTR_CSW)) {
    sub KTR_CSW () {	6;}
}
unless(defined(&KTR_EMUL)) {
    sub KTR_EMUL () {	7;}
}
unless(defined(&KTR_STRUCT)) {
    sub KTR_STRUCT () {	8;}
}
unless(defined(&KTRFAC_MASK)) {
    sub KTRFAC_MASK () {	0xffffff;}
}
unless(defined(&KTRFAC_SYSCALL)) {
    sub KTRFAC_SYSCALL () {	(1<< &KTR_SYSCALL);}
}
unless(defined(&KTRFAC_SYSRET)) {
    sub KTRFAC_SYSRET () {	(1<< &KTR_SYSRET);}
}
unless(defined(&KTRFAC_NAMEI)) {
    sub KTRFAC_NAMEI () {	(1<< &KTR_NAMEI);}
}
unless(defined(&KTRFAC_GENIO)) {
    sub KTRFAC_GENIO () {	(1<< &KTR_GENIO);}
}
unless(defined(&KTRFAC_PSIG)) {
    sub KTRFAC_PSIG () {	(1<< &KTR_PSIG);}
}
unless(defined(&KTRFAC_CSW)) {
    sub KTRFAC_CSW () {	(1<< &KTR_CSW);}
}
unless(defined(&KTRFAC_EMUL)) {
    sub KTRFAC_EMUL () {	(1<< &KTR_EMUL);}
}
unless(defined(&KTRFAC_STRUCT)) {
    sub KTRFAC_STRUCT () {	(1<< &KTR_STRUCT);}
}
unless(defined(&KTRFAC_ROOT)) {
    sub KTRFAC_ROOT () {	0x80000000;}
}
unless(defined(&KTRFAC_INHERIT)) {
    sub KTRFAC_INHERIT () {	0x40000000;}
}
unless(defined(&_KERNEL)) {
    require 'sys/cdefs.ph';
} else {
    eval 'sub ktrsockaddr {
        my($p, $s, $l) = @_;
	    eval q( &ktrstruct(($p), \\"sockaddr\\", ($s), ($l)));
    }' unless defined(&ktrsockaddr);
    eval 'sub ktrstat {
        my($p, $s) = @_;
	    eval q( &ktrstruct(($p), \\"stat\\", ($s), $sizeof{\'struct stat\'}));
    }' unless defined(&ktrstat);
    eval 'sub ktrabstimespec {
        my($p, $s) = @_;
	    eval q( &ktrstruct(($p), \\"abstimespec\\", ($s), $sizeof{\'struct timespec\'}));
    }' unless defined(&ktrabstimespec);
    eval 'sub ktrreltimespec {
        my($p, $s) = @_;
	    eval q( &ktrstruct(($p), \\"reltimespec\\", ($s), $sizeof{\'struct timespec\'}));
    }' unless defined(&ktrreltimespec);
    eval 'sub ktrabstimeval {
        my($p, $s) = @_;
	    eval q( &ktrstruct(($p), \\"abstimeval\\", ($s), $sizeof{\'struct timeval\'}));
    }' unless defined(&ktrabstimeval);
    eval 'sub ktrreltimeval {
        my($p, $s) = @_;
	    eval q( &ktrstruct(($p), \\"reltimeval\\", ($s), $sizeof{\'struct timeval\'}));
    }' unless defined(&ktrreltimeval);
    eval 'sub ktrsigaction {
        my($p, $s) = @_;
	    eval q( &ktrstruct(($p), \\"sigaction\\", ($s), $sizeof{\'struct sigaction\'}));
    }' unless defined(&ktrsigaction);
    eval 'sub ktrrlimit {
        my($p, $s) = @_;
	    eval q( &ktrstruct(($p), \\"rlimit\\", ($s), $sizeof{\'struct rlimit\'}));
    }' unless defined(&ktrrlimit);
    eval 'sub ktrfdset {
        my($p, $s, $l) = @_;
	    eval q( &ktrstruct(($p), \\"fdset\\", ($s), $l));
    }' unless defined(&ktrfdset);
}
1;
