require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_KERNEL)) {
    require 'sys/cdefs.ph';
}
unless(defined(&PROT_NONE)) {
    sub PROT_NONE () {	0x;}
}
unless(defined(&PROT_READ)) {
    sub PROT_READ () {	0x1;}
}
unless(defined(&PROT_WRITE)) {
    sub PROT_WRITE () {	0x2;}
}
unless(defined(&PROT_EXEC)) {
    sub PROT_EXEC () {	0x4;}
}
unless(defined(&MAP_SHARED)) {
    sub MAP_SHARED () {	0x1;}
}
unless(defined(&MAP_PRIVATE)) {
    sub MAP_PRIVATE () {	0x2;}
}
unless(defined(&MAP_COPY)) {
    sub MAP_COPY () {	0x4;}
}
unless(defined(&MAP_FIXED)) {
    sub MAP_FIXED () {	0x10;}
}
unless(defined(&MAP_RENAME)) {
    sub MAP_RENAME () {	0x20;}
}
unless(defined(&MAP_NORESERVE)) {
    sub MAP_NORESERVE () {	0x40;}
}
unless(defined(&MAP_INHERIT)) {
    sub MAP_INHERIT () {	0x80;}
}
unless(defined(&MAP_NOEXTEND)) {
    sub MAP_NOEXTEND () {	0x100;}
}
unless(defined(&MAP_HASSEMAPHORE)) {
    sub MAP_HASSEMAPHORE () {	0x200;}
}
unless(defined(&MAP_TRYFIXED)) {
    sub MAP_TRYFIXED () {	0x400;}
}
unless(defined(&__MAP_NOREPLACE)) {
    sub __MAP_NOREPLACE () {	0x800;}
}
unless(defined(&MAP_FAILED)) {
    sub MAP_FAILED () {	(( &void *)-1);}
}
unless(defined(&MAP_FILE)) {
    sub MAP_FILE () {	0x;}
}
unless(defined(&MAP_ANON)) {
    sub MAP_ANON () {	0x1000;}
}
unless(defined(&MAP_FLAGMASK)) {
    sub MAP_FLAGMASK () {	0x1ff7;}
}
unless(defined(&POSIX_MADV_NORMAL)) {
    sub POSIX_MADV_NORMAL () {	0;}
}
unless(defined(&POSIX_MADV_RANDOM)) {
    sub POSIX_MADV_RANDOM () {	1;}
}
unless(defined(&POSIX_MADV_SEQUENTIAL)) {
    sub POSIX_MADV_SEQUENTIAL () {	2;}
}
unless(defined(&POSIX_MADV_WILLNEED)) {
    sub POSIX_MADV_WILLNEED () {	3;}
}
unless(defined(&POSIX_MADV_DONTNEED)) {
    sub POSIX_MADV_DONTNEED () {	4;}
}
if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
    eval 'sub MADV_NORMAL () { &POSIX_MADV_NORMAL;}' unless defined(&MADV_NORMAL);
    eval 'sub MADV_RANDOM () { &POSIX_MADV_RANDOM;}' unless defined(&MADV_RANDOM);
    eval 'sub MADV_SEQUENTIAL () { &POSIX_MADV_SEQUENTIAL;}' unless defined(&MADV_SEQUENTIAL);
    eval 'sub MADV_WILLNEED () { &POSIX_MADV_WILLNEED;}' unless defined(&MADV_WILLNEED);
    eval 'sub MADV_DONTNEED () { &POSIX_MADV_DONTNEED;}' unless defined(&MADV_DONTNEED);
    eval 'sub MADV_SPACEAVAIL () {5;}' unless defined(&MADV_SPACEAVAIL);
    eval 'sub MADV_FREE () {6;}' unless defined(&MADV_FREE);
}
unless(defined(&MAP_INHERIT_SHARE)) {
    sub MAP_INHERIT_SHARE () {	0;}
}
unless(defined(&MAP_INHERIT_COPY)) {
    sub MAP_INHERIT_COPY () {	1;}
}
unless(defined(&MAP_INHERIT_NONE)) {
    sub MAP_INHERIT_NONE () {	2;}
}
unless(defined(&MAP_INHERIT_DONATE_COPY)) {
    sub MAP_INHERIT_DONATE_COPY () {	3;}
}
unless(defined(&MS_ASYNC)) {
    sub MS_ASYNC () {	0x1;}
}
unless(defined(&MS_SYNC)) {
    sub MS_SYNC () {	0x2;}
}
unless(defined(&MS_INVALIDATE)) {
    sub MS_INVALIDATE () {	0x4;}
}
unless(defined(&MCL_CURRENT)) {
    sub MCL_CURRENT () {	0x1;}
}
unless(defined(&MCL_FUTURE)) {
    sub MCL_FUTURE () {	0x2;}
}
unless(defined(&_KERNEL)) {
    require 'sys/_types.ph';
    unless(defined(&_SIZE_T_DEFINED_)) {
	eval 'sub _SIZE_T_DEFINED_ () {1;}' unless defined(&_SIZE_T_DEFINED_);
    }
    unless(defined(&_OFF_T_DEFINED_)) {
	eval 'sub _OFF_T_DEFINED_ () {1;}' unless defined(&_OFF_T_DEFINED_);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
    }
}
1;
